package com.minecraftserverzone.weaponmaster.gui;

import java.io.IOException;

import org.lwjgl.input.Mouse;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.gui.normalbutton.Button;
import com.minecraftserverzone.weaponmaster.gui.slider.NewForgeSlider;
import com.minecraftserverzone.weaponmaster.gui.smallButton.SmallButton;
import com.minecraftserverzone.weaponmaster.gui.togglebutton.ToggleButton;
import com.minecraftserverzone.weaponmaster.setup.Helper;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.server.PositionsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.RotationsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.ScaleSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.SlotAttachmentSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.SlotMoverSPacket;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;

public class DetailedSettingsScreen extends GuiScreen {
	public static final ResourceLocation BG = new ResourceLocation(WeaponMasterMod.MODID, "textures/gui/gui_page_version.png");
	public static int selectedScreen = 0;
	public boolean draggingPlayerMode = false;
	public static int scale = 0;
	public String[] bodyattachments = ClientOnlyForgeSetup.slotAttachment.split(",");
	public String[][] bodyattachment = new String[WeaponMasterMod.maxDisplaySlotNum][2];
	private ToggleButton[][] attachmentButton = new ToggleButton[WeaponMasterMod.maxDisplaySlotNum][6];
	private ToggleButton[] slotMoverSlots = new ToggleButton[WeaponMasterMod.maxDisplaySlotNum];
	private static ToggleButton[] slotButton = new ToggleButton[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] posx = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] posy = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] posz = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] rotx = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] roty = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] rotz = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static NewForgeSlider[] scaleButton = new NewForgeSlider[WeaponMasterMod.maxDisplaySlotNum];
	private static SmallButton scalePlus;
	private static SmallButton scaleMinus;
	
	private static SmallButton posxplus;
	private static SmallButton posyplus;
	private static SmallButton poszplus;
	private static SmallButton rotxplus;
	private static SmallButton rotyplus;
	private static SmallButton rotzplus;
	
	private static SmallButton posxminus;
	private static SmallButton posyminus;
	private static SmallButton poszminus;
	private static SmallButton rotxminus;
	private static SmallButton rotyminus;
	private static SmallButton rotzminus;
	
	private Button blacklistbutton;
	private Button whitelistbutton;
	private Button uniqueitemsettings;
	private Button resetbutton;
	
	private ToggleButton helmet;
	private ToggleButton chestplate;
	private ToggleButton legs;
	private ToggleButton boots;
	private ToggleButton slotMoverX;
	private ToggleButton slotMoverY;
	private ToggleButton slotMoverZ;
	private ToggleButton slotMoverPlus;
	private ToggleButton slotMoverMinus;
	private String[] moveSlots = ClientOnlyForgeSetup.slotMover.split("_"); //divide to 12 slots
	private String[][] moveTypes = {
				moveSlots[0].split(";"), //"1,2,5,helm,chest;x;+" -> [0 -> "1,2,5,helm,chest"]  [1 -> "x"]  [2 -> "plus"]
				moveSlots[1].split(";"),
				moveSlots[2].split(";"),
				moveSlots[3].split(";"),
				moveSlots[4].split(";"),
				moveSlots[5].split(";"),
				moveSlots[6].split(";"),
				moveSlots[7].split(";"),
				moveSlots[8].split(";"),
				moveSlots[9].split(";"),
				moveSlots[10].split(";"),
				moveSlots[11].split(";"),
				moveSlots[12].split(";")
			};
	
	public DetailedSettingsScreen(int i) {
		selectedScreen = i;
	}
	
	public void openWhitelist() {
		Minecraft.func_71410_x().func_147108_a(new EditTextListScreen(0));
		
	}
	
	public void openBlacklist() {
		Minecraft.func_71410_x().func_147108_a(new EditTextListScreen(1));
		
	}
	
	public void openUniqueItemSettings() {
		Minecraft.func_71410_x().func_147108_a(new UniqueItemSettingScreen());
		
	}

	@Override
	public void func_73866_w_() {
		//blacklist whitelist
		this.field_146292_n.add(blacklistbutton = (new Button(this.field_146294_l / 2 , this.field_146295_m - 22, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.blacklist").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.blacklist"), (p_96337_) -> {
			openBlacklist();
		})));
		this.field_146292_n.add(whitelistbutton = (new Button(this.field_146294_l / 2 - 10 - field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.whitelist").func_150254_d()), this.field_146295_m - 22, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.whitelist").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.whitelist"), (p_96337_) -> {
			openWhitelist();
		})));
		this.field_146292_n.add(uniqueitemsettings = (new Button(this.field_146294_l / 2 + 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.blacklist").func_150254_d()), this.field_146295_m - 22, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen4").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen4"), (p_96337_) -> {
			openUniqueItemSettings();
		})));
		
		//reset button
		this.field_146292_n.add(resetbutton = (new Button(4, this.field_146295_m - 23, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.reset").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.reset"), (p_96337_) -> {
			resetConfig();
		})));
		
		//slot select
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			bodyattachment[i][0] = bodyattachments[i].split("-")[0];
			bodyattachment[i][1] = bodyattachments[i].split("-")[1];
			
			final int slot = i;
			ITextComponent text = new TextComponentString(String.valueOf(slot+1));
			int xsize = 16;
			int xpos = 1 + (slot * 16);
			int ypos = 0;
			
			if(i == 9) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
				xpos = 1 + (slot * 16);
			}else if(i == 10) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d());
				xpos = 4 + (slot * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			}else if(i == 11) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.offhand");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.offhand").func_150254_d());
				xpos = 8 + (slot * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d()) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			}else if(i == 12) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.quiver");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.quiver").func_150254_d());
				xpos = 8 + ((slot-1) * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d()) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			
			}
			
			this.field_146292_n.add(slotButton[i] = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
				openOtherScreen(slot);
			}, slot == selectedScreen ? true : false, 0)));
			
			//pos and rot buttons
			xpos = 22;
			ypos = 131;
			this.field_146292_n.add(posx[i] = (new NewForgeSlider(xpos, ypos - 83, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posx"), new TextComponentString(""), ClientOnlyForgeSetup.slotPositions[i * 3] - 100, ClientOnlyForgeSetup.slotPositions[i * 3] + 100, ClientOnlyForgeSetup.slotPositions[i * 3], true)));
			this.field_146292_n.add(posy[i] = (new NewForgeSlider(xpos, ypos - 69, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posy"), new TextComponentString(""), ClientOnlyForgeSetup.slotPositions[(i * 3) + 1] - 100, ClientOnlyForgeSetup.slotPositions[(i * 3) + 1] + 100, ClientOnlyForgeSetup.slotPositions[(i * 3) + 1], true)));
			this.field_146292_n.add(posz[i] = (new NewForgeSlider(xpos, ypos - 55, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posz"), new TextComponentString(""), ClientOnlyForgeSetup.slotPositions[(i * 3) + 2] - 100, ClientOnlyForgeSetup.slotPositions[(i * 3) + 2] + 100, ClientOnlyForgeSetup.slotPositions[(i * 3) + 2], true)));
			
			this.field_146292_n.add(rotx[i] = (new NewForgeSlider(xpos, ypos - 38, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.rotx"), new TextComponentString(""), -180, 180, ClientOnlyForgeSetup.slotRotations[i * 3], true)));
			this.field_146292_n.add(roty[i] = (new NewForgeSlider(xpos, ypos - 24, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.roty"), new TextComponentString(""), -180, 180, ClientOnlyForgeSetup.slotRotations[(i * 3) + 1], true)));
			this.field_146292_n.add(rotz[i] = (new NewForgeSlider(xpos, ypos - 10, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.rotz"), new TextComponentString(""), -180, 180, ClientOnlyForgeSetup.slotRotations[(i * 3) + 2], true)));
		
			this.field_146292_n.add(scaleButton[i] = (new NewForgeSlider(xpos, ypos + 9, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.scale"), new TextComponentString(""), -100, 100, ClientOnlyForgeSetup.scale[i], true)));
			
			
			
			//attachment buttons
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.head").func_150254_d());
			xpos = 5;
			ypos = 260;
			this.field_146292_n.add(attachmentButton[i][0] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.head"), (p_96337_) -> {
				setAttachment(slot, "head");
			}, bodyattachment[i][1].equals("head"), 1)));
			
			xpos = 5;
			ypos = 280;
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.body").func_150254_d());
			this.field_146292_n.add(attachmentButton[i][1] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.body"), (p_96337_) -> {
				setAttachment(slot, "body");
			}, bodyattachment[i][1].equals("body"), 1 )));
			
			xpos = 5;
			ypos = 300;
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.larm").func_150254_d());
			this.field_146292_n.add(attachmentButton[i][3] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.larm"), (p_96337_) -> {
				setAttachment(slot, "larm");
			}, bodyattachment[i][1].equals("larm"), 1)));
			
			xpos += xsize;
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rarm").func_150254_d());
			this.field_146292_n.add(attachmentButton[i][2] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rarm"), (p_96337_) -> {
				setAttachment(slot, "rarm");
			}, bodyattachment[i][1].equals("rarm"), 1)));
			
			xpos = 5;
			ypos = 320;
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.lleg").func_150254_d());
			this.field_146292_n.add(attachmentButton[i][5] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.lleg"), (p_96337_) -> {
				setAttachment(slot, "lleg");
			}, bodyattachment[i][1].equals("lleg"), 1)));
			
			xpos += xsize;
			xsize = 10 + field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rleg").func_150254_d());
			this.field_146292_n.add(attachmentButton[i][4] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rleg"), (p_96337_) -> {
				setAttachment(slot, "rleg");
			}, bodyattachment[i][1].equals("rleg"), 1)));
			
			
			
			
/*************** TODO SLOT MOVERS ***************/
			
			xsize = 12;
			xpos = 5 + (slot * xsize);
			ypos = 190;
			String string = text.func_150254_d();
			if(i == 9) {
				text = new TextComponentString("");
				string = "shield";
			}else if(i == 10) {
				text = new TextComponentString("");
				string = "banner";
			}else if(i == 11) {
				text = new TextComponentString("O");
				string = "offhand";
			}else if(i == 12) {
				text = new TextComponentString("Q");
				string = "quiver";
			}
			final String str = string;
			
			this.field_146292_n.add(slotMoverSlots[i] = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
					//openOtherScreen(slot);
					changeSlotMover(selectedScreen, slot, 0, str);
			}, moveSlots[selectedScreen].contains(str), i == selectedScreen ? 1 : 0)));
		}
		

	{
		//slot mover for equipments
		ITextComponent text = new TextComponentString("");//helmet
		int xsize = 14;
		int xpos = 3;
		int ypos = 215;
		int slot = 1;
		this.field_146292_n.add(helmet = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 0, "helm");
		}, moveSlots[selectedScreen].contains("helm"), 0)));
		
		xpos = 3 + xsize; //chest
		this.field_146292_n.add(chestplate = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 0, "chest");
		}, moveSlots[selectedScreen].contains("chest"), 0)));
		
		xpos = 3 + xsize * 2; //legs
		this.field_146292_n.add(legs = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 0, "legs");
		}, moveSlots[selectedScreen].contains("legs"), 0)));
		
		xpos = 3 + xsize *3; //boots
		this.field_146292_n.add(boots = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 0, "boots");
		}, moveSlots[selectedScreen].contains("boots"), 0)));
		
		//xyz +- buttons
		xsize = 12;
		text = new TextComponentString("x");
		xpos = 80;
		ypos = 215;
		this.field_146292_n.add(slotMoverX = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 1, "x");
		}, moveTypes[selectedScreen][1].equals("x"), 0)));
		
		text = new TextComponentString("y");
		xpos = 80 + xsize;
		this.field_146292_n.add(slotMoverY = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 1, "y");
		}, moveTypes[selectedScreen][1].equals("y"), 0)));
		
		text = new TextComponentString("z");
		xpos = 80 + (xsize*2);
		this.field_146292_n.add(slotMoverZ = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 1, "z");
		}, moveTypes[selectedScreen][1].equals("z"), 0)));
		
		text = new TextComponentString("+");
		xpos = 80 + (xsize*3);
		this.field_146292_n.add(slotMoverPlus = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 2, "+");
		}, moveTypes[selectedScreen][2].equals("+"), 0)));
		
		text = new TextComponentString("-");
		xpos = 80 + (xsize*4);
		this.field_146292_n.add(slotMoverMinus = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
			changeSlotMover(selectedScreen, slot, 2, "-");
		}, moveTypes[selectedScreen][2].equals("-"), 0)));
	}

		
		//plus minus and slider buttons
		int xsize = 12;
		ITextComponent text = new TextComponentString(">");
		int xpos = 130;
		int ypos = 120;
		this.field_146292_n.add(posxplus = (new SmallButton(xpos, ypos - 72, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "x", true); //position or rotation, direction - xyz, plus or minus
		})));
		this.field_146292_n.add(posyplus = (new SmallButton(xpos, ypos - 58, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "y", true);
		})));
		this.field_146292_n.add(poszplus = (new SmallButton(xpos, ypos - 44, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "z", true);
		})));
		
		this.field_146292_n.add(rotxplus = (new SmallButton(xpos, ypos - 27, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "x", true);
		})));
		this.field_146292_n.add(rotyplus = (new SmallButton(xpos, ypos - 13, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "y", true);
		})));
		this.field_146292_n.add(rotzplus = (new SmallButton(xpos, ypos + 1, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "z", true);
		})));
		
		//minus
		xsize = 12;
		text = new TextComponentString("<");
		xpos = 1;
		ypos = 120;
		this.field_146292_n.add(posxminus = (new SmallButton(xpos, ypos - 72, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "x", false); //position or rotation, direction - xyz, plus or minus
		})));
		this.field_146292_n.add(posyminus = (new SmallButton(xpos, ypos - 58, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "y", false);
		})));
		this.field_146292_n.add(poszminus = (new SmallButton(xpos, ypos - 44, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "z", false);
		})));
		
		this.field_146292_n.add(rotxminus = (new SmallButton(xpos, ypos - 27, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "x", false);
		})));
		this.field_146292_n.add(rotyminus = (new SmallButton(xpos, ypos - 13, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "y", false);
		})));
		this.field_146292_n.add(rotzminus = (new SmallButton(xpos, ypos + 1, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "z", false);
		})));
		
		//scale buttons
		ypos = 120;
		xpos = 130;
		this.field_146292_n.add(scalePlus = (new SmallButton(xpos, ypos + 20, xsize, 13, new TextComponentString(">"), (p_96337_) -> {
			changePosOrRot(false, "scale", true);
		})));
		xpos = 1;
		this.field_146292_n.add(scaleMinus = (new SmallButton(xpos, ypos + 20, xsize, 13, new TextComponentString("<"), (p_96337_) -> {
			changePosOrRot(false, "scale", false);
		})));
		
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			if(i != selectedScreen) {
				visible(i, false);
			}else {
				visible(i, true);
			}
		}
		
		super.func_73866_w_();
	}
	
	public void changeSlotMover(int selectedScreen, int slot, int id, String containedstr) {
		/** TODO **/
		if(id == 0) {
			if(this.moveTypes[selectedScreen][id].contains(containedstr)){
				//remove it from the list
					String newstr = this.moveTypes[selectedScreen][id].replace(","+containedstr, "");
					this.moveTypes[selectedScreen][id] = newstr;
			}else {
				//add it to the list
				this.moveTypes[selectedScreen][id] += ","+containedstr;
			}
			
		}else {
			this.moveTypes[selectedScreen][id] = containedstr;
		}
		
		String newstr = this.moveTypes[selectedScreen][id].replace(",,", ",");
		this.moveTypes[selectedScreen][id] = newstr;
		
		String string = "";
		for(int i = 0; i < moveTypes.length; i++) {
			for(int j = 0; j < moveTypes[selectedScreen].length; j++) {
				string += moveTypes[i][j];
				if(j != moveTypes[selectedScreen].length - 1) {
					string += ";";
				}
				
				
			}
			if(i != moveTypes.length - 1) {
				string += "_";
			}
		}
		
		ClientOnlyForgeSetup.slotMover = string;
		moveSlots = ClientOnlyForgeSetup.slotMover.split("_"); //divide to 9 slots
		String[][] moveTypes2 = {
					moveSlots[0].split(";"), //"1,2,5,helm,chest;x;+" -> [0 -> "1,2,5,helm,chest"]  [1 -> "x"]  [2 -> "plus"]
					moveSlots[1].split(";"),
					moveSlots[2].split(";"),
					moveSlots[3].split(";"),
					moveSlots[4].split(";"),
					moveSlots[5].split(";"),
					moveSlots[6].split(";"),
					moveSlots[7].split(";"),
					moveSlots[8].split(";"),
					moveSlots[9].split(";"),
					moveSlots[10].split(";"),
					moveSlots[11].split(";"),
					moveSlots[12].split(";")
				}; //"1,2,5,body,leg;x;plus" -> divide the 3 types for the 9 slots
		moveTypes = moveTypes2;
		
		changeMover();
	}
	
	public void changeMover(){
		/** TODO change slot mover buttons toggle value */
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			slotMoverSlots[i].toggle = moveSlots[selectedScreen].contains(String.valueOf(i+1));
		}
		slotMoverSlots[9].toggle = moveSlots[selectedScreen].contains(String.valueOf("shield"));
		slotMoverSlots[10].toggle = moveSlots[selectedScreen].contains(String.valueOf("banner"));
		slotMoverSlots[11].toggle = moveSlots[selectedScreen].contains(String.valueOf("offhand"));
		slotMoverSlots[12].toggle = moveSlots[selectedScreen].contains(String.valueOf("quiver"));
		
		helmet.toggle = moveSlots[selectedScreen].contains("helm");
		chestplate.toggle = moveSlots[selectedScreen].contains("chest");
		legs.toggle = moveSlots[selectedScreen].contains("legs");
		boots.toggle = moveSlots[selectedScreen].contains("boots");
		
		slotMoverX.toggle = moveTypes[selectedScreen][1].equals("x");
		slotMoverY.toggle = moveTypes[selectedScreen][1].equals("y");
		slotMoverZ.toggle = moveTypes[selectedScreen][1].equals("z");
		slotMoverPlus.toggle = moveTypes[selectedScreen][2].equals("+");
		slotMoverMinus.toggle = moveTypes[selectedScreen][2].equals("-");
	}
	
	private void setAttachment(int slot, String string) {
		bodyattachment[slot][1] = string;
		String newString = "";
		
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			newString += bodyattachment[i][0]+"-";
			newString += bodyattachment[i][1];
			if(i != WeaponMasterMod.maxDisplaySlotNum -1) {
				newString += ",";
			}
		}
		ClientOnlyForgeSetup.slotAttachment = newString;
		bodyattachments = ClientOnlyForgeSetup.slotAttachment.split(",");
		
		if(string.equals("head")) {
			attachmentButton[selectedScreen][0].toggle = true;
			attachmentButton[selectedScreen][1].toggle = false;
			attachmentButton[selectedScreen][2].toggle = false;
			attachmentButton[selectedScreen][3].toggle = false;
			attachmentButton[selectedScreen][4].toggle = false;
			attachmentButton[selectedScreen][5].toggle = false;
		}else if(string.equals("body")) {
			attachmentButton[selectedScreen][0].toggle = false;
			attachmentButton[selectedScreen][1].toggle = true;
			attachmentButton[selectedScreen][2].toggle = false;
			attachmentButton[selectedScreen][3].toggle = false;
			attachmentButton[selectedScreen][4].toggle = false;
			attachmentButton[selectedScreen][5].toggle = false;
		}else if(string.equals("rarm")) {
			attachmentButton[selectedScreen][0].toggle = false;
			attachmentButton[selectedScreen][1].toggle = false;
			attachmentButton[selectedScreen][2].toggle = true;
			attachmentButton[selectedScreen][3].toggle = false;
			attachmentButton[selectedScreen][4].toggle = false;
			attachmentButton[selectedScreen][5].toggle = false;
		}else if(string.equals("larm")) {
			attachmentButton[selectedScreen][0].toggle = false;
			attachmentButton[selectedScreen][1].toggle = false;
			attachmentButton[selectedScreen][2].toggle = false;
			attachmentButton[selectedScreen][3].toggle = true;
			attachmentButton[selectedScreen][4].toggle = false;
			attachmentButton[selectedScreen][5].toggle = false;
		}else if(string.equals("rleg")) {
			attachmentButton[selectedScreen][0].toggle = false;
			attachmentButton[selectedScreen][1].toggle = false;
			attachmentButton[selectedScreen][2].toggle = false;
			attachmentButton[selectedScreen][3].toggle = false;
			attachmentButton[selectedScreen][4].toggle = true;
			attachmentButton[selectedScreen][5].toggle = false;
		}else if(string.equals("lleg")) {
			attachmentButton[selectedScreen][0].toggle = false;
			attachmentButton[selectedScreen][1].toggle = false;
			attachmentButton[selectedScreen][2].toggle = false;
			attachmentButton[selectedScreen][3].toggle = false;
			attachmentButton[selectedScreen][4].toggle = false;
			attachmentButton[selectedScreen][5].toggle = true;
		}
	}
	
	private void changePosOrRot(boolean position, String direction, boolean plus) {
		if(direction.equals("scale")) {
			if(plus && scaleButton[selectedScreen].value <= 0.99d) {
				scaleButton[selectedScreen].setSliderValue(scaleButton[selectedScreen].value + 0.005d);
			}else if(!plus && scaleButton[selectedScreen].value >= 0.01d) {
				scaleButton[selectedScreen].setSliderValue(scaleButton[selectedScreen].value - 0.005d);
			}
			
		}else if(position) {
			//change slider values
			if(plus) {
				if(direction.equals("x") && posx[selectedScreen].value <= 0.99d) {
					posx[selectedScreen].setSliderValue(posx[selectedScreen].value + 0.005d);
				}else if(direction.equals("y") && posy[selectedScreen].value <= 0.99d) {
					posy[selectedScreen].setSliderValue(posy[selectedScreen].value + 0.005d);
				}else if(direction.equals("z") && posz[selectedScreen].value <= 0.99d) {
					posz[selectedScreen].setSliderValue(posz[selectedScreen].value + 0.005d);
				}
			}else {
				if(direction.equals("x") && posx[selectedScreen].value >= 0.01d) {
					posx[selectedScreen].setSliderValue(posx[selectedScreen].value - 0.005d);
				}else if(direction.equals("y") && posy[selectedScreen].value >= 0.01d) {
					posy[selectedScreen].setSliderValue(posy[selectedScreen].value - 0.005d);
				}else if(direction.equals("z") && posz[selectedScreen].value >= 0.01d) {
					posz[selectedScreen].setSliderValue(posz[selectedScreen].value - 0.005d);
				}
			}
		}else {
			//change slider values
			if(plus) {
				if(direction.equals("x") && rotx[selectedScreen].value <= 0.99d) {
					rotx[selectedScreen].setSliderValue(rotx[selectedScreen].value + 0.0025d);
				}else if(direction.equals("y") && roty[selectedScreen].value <= 0.99d) {
					roty[selectedScreen].setSliderValue(roty[selectedScreen].value + 0.0025d);
				}else if(direction.equals("z") && rotz[selectedScreen].value <= 0.99d) {
					rotz[selectedScreen].setSliderValue(rotz[selectedScreen].value + 0.0025d);
				}
			}else {
				if(direction.equals("x") && rotx[selectedScreen].value >= 0.01d) {
					rotx[selectedScreen].setSliderValue(rotx[selectedScreen].value - 0.0025d);
				}else if(direction.equals("y") && roty[selectedScreen].value >= 0.01d) {
					roty[selectedScreen].setSliderValue(roty[selectedScreen].value - 0.0025d);
				}else if(direction.equals("z") && rotz[selectedScreen].value >= 0.01d) {
					rotz[selectedScreen].setSliderValue(rotz[selectedScreen].value - 0.0025d);
				}
			}
		}
		
		setData();
	}
	
	public void resetConfig() {
		//slot positions, rotations
				resetPositionsRotations(0, 0, 0, -2, 0, 0, 0, 0); 
				resetPositionsRotations(1, 35, 35, 0, 0, 0, 90, 0); 
				resetPositionsRotations(2, 1, -20, 12, 0, -90, 0, 0); 
				resetPositionsRotations(3, 32, -20, 12, 0, -90, 0, 0); 
				resetPositionsRotations(4, 1, -24, 0, 0, -90, -30, 0); 
				resetPositionsRotations(5, 31, -24, 0, 0, -90, -30, 0); 
				resetPositionsRotations(6, -13, 34, -1, 0, 0, -35, 0); 
				resetPositionsRotations(7, 25, 20, 12, 0, 0, 45, 0); 
				resetPositionsRotations(8, 1, -14, 20, 0, -90, 20, 0); 
				resetPositionsRotations(9, 0, 0, 0, 0, 0, 0, 0);
				resetPositionsRotations(10, 0, 0, 0, 0, 0, 0, 0);
				resetPositionsRotations(11, -2, 22, -14, 110, 90, 0, 0);
				resetPositionsRotations(12, 0, 0, 15, 0, 0, 0, 0);
	}

	public void resetPositionsRotations(int i, int x, int y, int z, int xr, int yr, int zr, int scale) {
		if(i == selectedScreen) {
			try {
			ClientOnlyForgeSetup.slotPositions[i * 3] = x;
			ClientOnlyForgeSetup.slotPositions[(i * 3)+ 1] = y;
			ClientOnlyForgeSetup.slotPositions[(i * 3)+ 2] = z;
			ClientOnlyForgeSetup.slotRotations[i * 3] = xr;
			ClientOnlyForgeSetup.slotRotations[(i * 3)+ 1] = yr;
			ClientOnlyForgeSetup.slotRotations[(i * 3)+ 2] = zr;
			ClientOnlyForgeSetup.scale[i] = scale;
			
			ConfigHelper.set("scale"+String.valueOf(i), ConfigHelper.scale[i] = ClientOnlyForgeSetup.scale[i]);
			
			ConfigHelper.set("x_position"+String.valueOf(i * 3), ConfigHelper.positions[i * 3] = ClientOnlyForgeSetup.slotPositions[i * 3]);
			ConfigHelper.set("y_position"+String.valueOf((i * 3)+ 1), ConfigHelper.positions[(i * 3) + 1] = ClientOnlyForgeSetup.slotPositions[(i * 3)+ 1]);
			ConfigHelper.set("z_position"+String.valueOf((i * 3)+ 2), ConfigHelper.positions[(i * 3) + 2] = ClientOnlyForgeSetup.slotPositions[(i * 3)+ 2]);
			
			ConfigHelper.set("x_rotation"+String.valueOf(i * 3), ConfigHelper.rotations[i * 3] = ClientOnlyForgeSetup.slotRotations[i * 3]);
			ConfigHelper.set("y_rotation"+String.valueOf((i * 3)+ 1), ConfigHelper.rotations[(i * 3) + 1] = ClientOnlyForgeSetup.slotRotations[(i * 3)+ 1]);
			ConfigHelper.set("z_rotation"+String.valueOf((i * 3)+ 2), ConfigHelper.rotations[(i * 3) + 2] = ClientOnlyForgeSetup.slotRotations[(i * 3)+ 2]);
			
			//reset buttons
			setValues(posx[i], ClientOnlyForgeSetup.slotPositions[i * 3], i);
			setValues(posy[i], ClientOnlyForgeSetup.slotPositions[(i * 3) + 1], i);
			setValues(posz[i], ClientOnlyForgeSetup.slotPositions[(i * 3) + 2], i);
			
			setValues(rotx[i], ClientOnlyForgeSetup.slotRotations[i * 3], i);
			setValues(roty[i], ClientOnlyForgeSetup.slotRotations[(i * 3) + 1], i);
			setValues(rotz[i], ClientOnlyForgeSetup.slotRotations[(i * 3) + 2], i);
			
			setValues(scaleButton[i], ClientOnlyForgeSetup.scale[i], i);
			
			ClientOnlyForgeSetup.slotAttachment = "1-body,2-body,3-rleg,4-lleg,5-rleg,6-lleg,7-body,8-body,9-rleg,shield-body,banner-head,offhand-lleg,quiver-body";
			ClientOnlyForgeSetup.slotMover = "none,chest;z;+_none,chest,1;z;+_none,legs;x;-_none,legs;x;+_none,legs,3;x;-_none,legs,4;x;+_none,chest,legs,1;z;+_none,shield;z;+_none,legs,3,5;x;-_none;z;-_none;z;-_none,legs,4,6;x;+_none;z;+";
			
			ConfigHelper.set("attachment", ConfigHelper.slot_attachment = ClientOnlyForgeSetup.slotAttachment);
			ConfigHelper.set("slot_mover", ConfigHelper.slotMover = ClientOnlyForgeSetup.slotMover);
			
			String[] bodyattachments = ClientOnlyForgeSetup.slotAttachment.split(",");
			String[][] bodyattachment = new String[WeaponMasterMod.maxDisplaySlotNum][2];
			bodyattachment[i][0] = bodyattachments[i].split("-")[0];
			bodyattachment[i][1] = bodyattachments[i].split("-")[1];
			
			if(bodyattachment[i][1].equals("head")) {
				attachmentButton[i][0].toggle = true;
			}else {
				attachmentButton[i][0].toggle = false;
			}
			
			if(bodyattachment[i][1].equals("body")) {
				attachmentButton[i][1].toggle = true;
			}else {
				attachmentButton[i][1].toggle = false;
			}

			if(bodyattachment[i][1].equals("rarm")) {
				attachmentButton[i][2].toggle = true;
			}else {
				attachmentButton[i][2].toggle = false;
			}
			
			if(bodyattachment[i][1].equals("larm")) {
				attachmentButton[i][3].toggle = true;
			}else {
				attachmentButton[i][3].toggle = false;
			}

			if(bodyattachment[i][1].equals("rleg")) {
				attachmentButton[i][4].toggle = true;
			}else {
				attachmentButton[i][4].toggle = false;
			}
			
			if(bodyattachment[i][1].equals("lleg")) {
				attachmentButton[i][5].toggle = true;
			}else {
				attachmentButton[i][5].toggle = false;
			}
			
			moveSlots = ClientOnlyForgeSetup.slotMover.split("_"); //divide to 9 slots
			String[][] moveTypes2 = {
						moveSlots[0].split(";"), //"1,2,5,helm,chest;x;+" -> [0 -> "1,2,5,helm,chest"]  [1 -> "x"]  [2 -> "plus"]
						moveSlots[1].split(";"),
						moveSlots[2].split(";"),
						moveSlots[3].split(";"),
						moveSlots[4].split(";"),
						moveSlots[5].split(";"),
						moveSlots[6].split(";"),
						moveSlots[7].split(";"),
						moveSlots[8].split(";"),
						moveSlots[9].split(";"),
						moveSlots[10].split(";"),
						moveSlots[11].split(";"),
						moveSlots[12].split(";")
					}; //"1,2,5,body,leg;x;plus" -> divide the 3 types for the 9 slots
			moveTypes = moveTypes2;
			changeMover();
			
			}catch (Exception e) {}
		}
	}
	
	public void setValues(NewForgeSlider b, double v, int i) {
//		b.minValue = v - 100;
//		b.maxValue = v + 100;
//		b.value = b.snapToNearest((v - b.minValue) / (b.maxValue - b.minValue));
//		
//		b.updateMessage();
		
		double minValue = v - 100;
		double maxValue = v + 100;
		
		if(b == scaleButton[i]) {
			minValue = -100;
			maxValue = 100;
		}
		if(b == rotx[i] || b == roty[i] || b == rotz[i]) {
			minValue = -180;
			maxValue = 180;
		}
		b.minValue = minValue;
		b.maxValue = maxValue;
		b.value = b.snapToNearest((v - b.minValue) / (b.maxValue - b.minValue));
		
		b.updateMessage();
	}

	public void openOtherScreen(int slot) {
		selectedScreen = slot;
		
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			if(i != slot) {
				visible(i, false);
			}else {
				visible(i, true);
			}
		}
		
		changeMover();
		
		saveAllData();
	}
	
	public void saveAllData() {
		//change server data
		if(WeaponMasterMod.isMultiplayer) {
			Networking.sendToServer(new PositionsSPacket(ClientOnlyForgeSetup.slotPositions));
			Networking.sendToServer(new RotationsSPacket(ClientOnlyForgeSetup.slotRotations));
			Networking.sendToServer(new ScaleSPacket(ClientOnlyForgeSetup.scale));
			Networking.sendToServer(new SlotAttachmentSPacket(ClientOnlyForgeSetup.slotAttachment));
			Networking.sendToServer(new SlotMoverSPacket(ClientOnlyForgeSetup.slotMover));
		}
		
	}
	
	public void visible(int i, boolean value) {
		slotMoverSlots[i].visible = !value;
		if(i == 11) {
			slotMoverSlots[i].visible = false;
			slotButton[i].visible = false;
		}
		slotButton[i].toggle = value;
		posx[i].visible = value;
		posy[i].visible = value;
		posz[i].visible = value;
		
		rotx[i].visible = value;
		roty[i].visible = value;
		rotz[i].visible = value;
		
		scaleButton[i].visible = value;
		
		attachmentButton[i][0].visible = value;
		attachmentButton[i][1].visible = value;
		attachmentButton[i][2].visible = value;
		attachmentButton[i][3].visible = value;
		attachmentButton[i][4].visible = value;
		attachmentButton[i][5].visible = value;
	}

	public void renderBackground(int p_299421_, int p_298679_, float p_297268_) {}
	
	@Override
	public void func_73863_a(int p_96563_, int p_96564_, float p_96565_) {
		this.func_73733_a(0, 0, this.field_146294_l, this.field_146295_m, -1072689136, -804253680);

		int screenHeight = this.field_146295_m;
		int screenWidth =  this.field_146294_l;
		
		GlStateManager.func_179094_E();
		
   		GuiHelper.drawString(field_146289_q, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach"), 5, 245, 0xffffff, false);

   		GuiHelper.drawString(field_146289_q, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".mover"), 5, 180, 0xffffff, false);
   		GuiHelper.drawString(field_146289_q, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".arrowright"), 64, 222, 0xffffff, false);

   		GuiHelper.drawString(field_146289_q, new TextComponentString(selectedScreen < 9 ? String.valueOf(selectedScreen+1) : ""),
				7 + (selectedScreen * 12), 196, 0xffffff, false);

		super.func_73863_a(p_96563_, p_96564_, p_96565_);
		
		Minecraft mc = Minecraft.func_71410_x();
		//button renderer
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			for(int j = 0; j < attachmentButton[i].length; j++) {
				if(attachmentButton[i][j].visible) {
					attachmentButton[i][j].func_146112_a(mc, p_96563_, p_96564_);
				}
			}
			
			if(slotMoverSlots[i].visible){
				if(i != 11) {
					slotMoverSlots[i].func_146112_a(mc, p_96563_, p_96564_);
				}
			}
			if(slotButton[i].visible){
				if(i != 11) {
					slotButton[i].func_146112_a(mc, p_96563_, p_96564_);
				}
			}

			if(this.posx[i].visible){
				this.posx[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			if(this.posy[i].visible){
				this.posy[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			if(this.posz[i].visible){
				this.posz[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			
			if(this.rotx[i].visible){
				this.rotx[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			if(this.roty[i].visible){
				this.roty[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			if(this.rotz[i].visible){
				this.rotz[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			
			if(this.scaleButton[i].visible){
				this.scaleButton[i].func_146112_a(mc, p_96563_, p_96564_);
			}
			
		}
		if(this.scalePlus.visible){
			this.scalePlus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.scaleMinus.visible){
			this.scaleMinus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.posxplus.visible){
			this.posxplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.posyplus.visible){
			this.posyplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.poszplus.visible){
			this.poszplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.rotxplus.visible){
			this.rotxplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.rotyplus.visible){
			this.rotyplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.rotzplus.visible){
			this.rotzplus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		
		if(this.posxminus.visible){
			this.posxminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.posyminus.visible){
			this.posyminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.poszminus.visible){
			this.poszminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.rotxminus.visible){
			this.rotxminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.rotyminus.visible){
			this.rotyminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.rotzminus.visible){
			this.rotzminus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.blacklistbutton.visible){
			this.blacklistbutton.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.whitelistbutton.visible){
			this.whitelistbutton.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.uniqueitemsettings.visible){
			this.uniqueitemsettings.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.resetbutton.visible){
			this.resetbutton.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.helmet.visible){
			this.helmet.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.chestplate.visible){
			this.chestplate.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.legs.visible){
			this.legs.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.boots.visible){
			this.boots.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		if(this.slotMoverX.visible){
			this.slotMoverX.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.slotMoverY.visible){
			this.slotMoverY.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.slotMoverZ.visible){
			this.slotMoverZ.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.slotMoverPlus.visible){
			this.slotMoverPlus.func_146112_a(mc, p_96563_, p_96564_);
		}
		if(this.slotMoverMinus.visible){
			this.slotMoverMinus.func_146112_a(mc, p_96563_, p_96564_);
		}
		
		
		//item renderer
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_185159_cQ), 111, 192);
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_179564_cE), 122, 192);
		
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_151161_ac), 1, 218);
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_151163_ad), 15, 218);
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_151173_ae), 29, 218);
		this.field_146296_j.func_175042_a(new ItemStack(Items.field_151175_af), 43, 218);
		
		WeaponMasterScreen.renderEntityInInventory(screenWidth/2, screenHeight/2 , 60 + scale, 0, 0, Minecraft.func_71410_x().field_71439_g);
		GlStateManager.func_179121_F();
	}
	
	@Override
	public boolean func_73868_f() {
		return true;
	}

	@Override
	protected void func_146273_a(int mouseX, int mouseY, int clickedMouseButton, long timeSinceLastClick) {
		if(this.draggingPlayerMode) {
			ClientOnlyForgeSetup.xRot = ClientOnlyForgeSetup.fakexRot - (int) (mouseX - ClientOnlyForgeSetup.xPos);
			ClientOnlyForgeSetup.yRot = ClientOnlyForgeSetup.fakeyRot - (int) (mouseY - ClientOnlyForgeSetup.yPos);
			
			if(ClientOnlyForgeSetup.xRot >= 360) {
				ClientOnlyForgeSetup.xRot -= 360;
			}else if(ClientOnlyForgeSetup.xRot <= -360) {
				ClientOnlyForgeSetup.xRot += 360;
			}
			if(ClientOnlyForgeSetup.yRot >= 360) {
				ClientOnlyForgeSetup.yRot -= 360;
			}else if(ClientOnlyForgeSetup.yRot <= -360) {
				ClientOnlyForgeSetup.yRot += 360;
			}
		}
		super.func_146273_a(mouseX, mouseY, clickedMouseButton, timeSinceLastClick);
	}
	
	@Override
	public void func_146274_d() throws IOException {
		super.func_146274_d();
		int p_94689_ = Integer.signum(Mouse.getEventDWheel());
		
		if(p_94689_ < 0 && p_94689_ + scale < -60) {
			scale = -60;
		}else if(p_94689_ > 0 && p_94689_ + scale > 160) {
			scale = 160;
		}else {
			scale += p_94689_*2;
		}
	}

	@Override
	protected void func_73864_a(int p_94695_, int p_94696_, int p_94697_) throws IOException {
		int screenHeight = this.field_146295_m;
		int screenWidth =  this.field_146294_l;
//		if(isMouseOverArea(p_94695_, p_94696_, screenWidth/2 + 10, screenHeight/2 - 60, 115, 125)) {
		if(isMouseOverArea(p_94695_, p_94696_, 0, 0, screenWidth, screenHeight) && !isMouseOverArea(p_94695_, p_94696_, 0, 0, 150, 160)) {
			this.draggingPlayerMode = true;
			ClientOnlyForgeSetup.xPos = (int) Math.floor(p_94695_);
			ClientOnlyForgeSetup.yPos = (int) Math.floor(p_94696_);
			ClientOnlyForgeSetup.fakexRot = ClientOnlyForgeSetup.xRot;
			ClientOnlyForgeSetup.fakeyRot = ClientOnlyForgeSetup.yRot;
		}
		super.func_73864_a(p_94695_, p_94696_, p_94697_);
	}

	@Override
	protected void func_146286_b(int p_94722_, int p_94723_, int p_94724_) {
		if(this.draggingPlayerMode) {
			this.draggingPlayerMode = false;
		}
		super.func_146286_b(p_94722_, p_94723_, p_94724_);
	}

	@Override
	public void func_146281_b() {
		close();
		super.func_146281_b();
	}
	
	public void close() {
		//save config
		Helper.setData();
		//open main settings screen
		saveAllData();
	}
	
	@Override
	public void func_73869_a(char p_96552_, int p_96553_) throws IOException {
		if(p_96553_ == KeyHandler.OPEN_SCREEN.func_151463_i()) {
			close();
			Minecraft.func_71410_x().func_147108_a(new WeaponMasterScreen());
		}
		super.func_73869_a(p_96552_, p_96553_);
	}

//	public static void renderEntityInInventory(int p_228187_0_, int p_228187_1_, int p_228187_2_, float p_228187_3_, float p_228187_4_, LivingEntity p_228187_5_) {
//	      float f = (float)Math.atan((double)(p_228187_3_ / 40.0F));
//	      float f1 = (float)Math.atan((double)(p_228187_4_ / 40.0F));
//	      RenderSystem.pushMatrix();
//	      RenderSystem.translatef((float)p_228187_0_, (float)p_228187_1_, 1050.0F);
//	      RenderSystem.scalef(1.0F, 1.0F, -1.0F);
//	      MatrixStack matrixstack = new MatrixStack();
//	      matrixstack.translate(0.0D, 0.0D, 1000.0D);
//	      matrixstack.scale((float)p_228187_2_, (float)p_228187_2_, (float)p_228187_2_);
//	      Quaternion quaternion = Vector3f.ZP.rotationDegrees(180.0F);
//	      Quaternion quaternion1 = Vector3f.XP.rotationDegrees(ClientOnlyForgeSetup.yRot + f1 * 20.0F);
//	      quaternion.mul(quaternion1);
//	      matrixstack.mulPose(quaternion);
//	      float f2 = p_228187_5_.yBodyRot;
//	      float f3 = p_228187_5_.yRot;
//	      float f4 = p_228187_5_.xRot;
//	      float f5 = p_228187_5_.yHeadRotO;
//	      float f6 = p_228187_5_.yHeadRot;
//	      p_228187_5_.yBodyRot = (ClientOnlyForgeSetup.xRot) + f * 20.0F;
//	      p_228187_5_.yRot = ClientOnlyForgeSetup.xRot + f * 40.0F;
//	      p_228187_5_.xRot = -f1 * 20.0F;
//	      p_228187_5_.yHeadRot = p_228187_5_.yRot;
//	      p_228187_5_.yHeadRotO = p_228187_5_.yRot;
//	      
//	      matrixstack.translate(0.0D, -0.9D, 0.0D);
//	      
//	      EntityRendererManager entityrenderermanager = Minecraft.getMinecraft().getEntityRenderDispatcher();
//	      quaternion1.conj();
//	      entityrenderermanager.overrideCameraOrientation(quaternion1);
//	      entityrenderermanager.setRenderShadow(false);
//	      IRenderTypeBuffer.Impl irendertypebuffer$impl = Minecraft.getMinecraft().renderBuffers().bufferSource();
//	      RenderSystem.runAsFancy(() -> {
//	         entityrenderermanager.drawButton(p_228187_5_, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F, matrixstack, irendertypebuffer$impl, 15728880);
//	      });
//	      irendertypebuffer$impl.endBatch();
//	      entityrenderermanager.setRenderShadow(true);
//	      p_228187_5_.yBodyRot = f2;
//	      p_228187_5_.yRot = f3;
//	      p_228187_5_.xRot = f4;
//	      p_228187_5_.yHeadRotO = f5;
//	      p_228187_5_.yHeadRot = f6;
//	      RenderSystem.popMatrix();
//	   }
	
	public boolean isMouseOverArea(double mouseX, double mouseY, int posX, int posY, int sizeX, int sizeY) {
		return (mouseX >= posX && mouseX < posX + sizeX && mouseY >= posY && mouseY < posY + sizeY);
	}

	public static void setData() {
		int i = selectedScreen;
		
		ClientOnlyForgeSetup.slotPositions[i * 3] = posx[i].getValueInt();
		ClientOnlyForgeSetup.slotPositions[(i * 3) + 1] = posy[i].getValueInt();
		ClientOnlyForgeSetup.slotPositions[(i * 3) + 2] = posz[i].getValueInt();
		
		ClientOnlyForgeSetup.slotRotations[i * 3] = rotx[i].getValueInt();
		ClientOnlyForgeSetup.slotRotations[(i * 3) + 1] = roty[i].getValueInt();
		ClientOnlyForgeSetup.slotRotations[(i * 3) + 2] = rotz[i].getValueInt();
		
		ClientOnlyForgeSetup.scale[i] = scaleButton[i].getValueInt();
	}
}
