package com.minecraftserverzone.weaponmaster.gui;

import java.io.IOException;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.gui.normalbutton.Button;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.FastColor;
import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.KeyHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ModUtils;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.server.BlacklistSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.WhitelistSPacket;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;

public class EditTextListScreen extends GuiScreen {
	public static int textType;
	public String text = "empty";
	public String textFromConfig = "empty";
	public boolean textFocused = false;
	public boolean selectText = false;
	private boolean draggingPlayerMode;
	public int hoverValue = 0;
	public boolean shiftDown = false;
	private Button normalbuttons;
	
	public EditTextListScreen(int i) {
		textType = i;
		if(textType == 0) {
			textFromConfig = ConfigHelper.whitelist;
		}else if(textType == 1) { //blacklist
			textFromConfig = ConfigHelper.blacklist;
		}
	}

	@Override
	public void func_73866_w_() {
		this.field_146292_n.add(normalbuttons = (new Button(field_146294_l/2 - 5 - field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.addtext").func_150254_d())/2, 50, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.addtext").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.addtext"), (p_96337_) -> {
			addText();
		})));
		
		super.func_73866_w_();
	}
	
	public void saveAllData() {
		if(WeaponMasterMod.isMultiplayer) {
			if(textType == 0) {
				Networking.sendToServer(new WhitelistSPacket(ClientOnlyForgeSetup.whitelist));
			}else {
				Networking.sendToServer(new BlacklistSPacket(ClientOnlyForgeSetup.blacklist));
			}
		}
	}
	
	public void addText() {
		if(ModUtils.stringExist(text) && !ModUtils.stringEquals(text, "empty")) {
			try {
			if(textType == 0) { //whitelist
				ClientOnlyForgeSetup.whitelist = ClientOnlyForgeSetup.whitelist+","+text;
				textFromConfig = ClientOnlyForgeSetup.whitelist;
				
			}else if(textType == 1) { //blacklist
				ClientOnlyForgeSetup.blacklist = ClientOnlyForgeSetup.blacklist+","+text;
				textFromConfig = ClientOnlyForgeSetup.blacklist;
			}
			text = "";
			
			}catch (Exception e) {}
		}
	}

//	public static void setClipboard(String p_95157_) {
//		Minecraft minecraft = Minecraft.getMinecraft();
//		if (minecraft != null) {
//			minecraft.keyboardHandler.setClipboard(p_95157_);
//		}
//	}
//	
//	public static String getClipboard() {
//		Minecraft minecraft = Minecraft.getMinecraft();
//		if(minecraft != null) {
//			return minecraft.keyboardHandler.getClipboard().replaceAll("\\r", "");
////			return ChatFormatting.stripFormatting(minecraft.keyboardHandler.getClipboard().replaceAll("\\r", ""));
//		}else {
//			return "";
//		}
//	}
	
	@Override
	protected void func_73869_a(char p_96553_, int p_96552_) throws IOException {
		if(SharedConstants.isAllowedCharacter(p_96553_) && textFocused) {
			text += p_96553_;
			text = SharedConstants.filterAllowedCharacters(text).toLowerCase();
			if(ModUtils.stringContains(text, ",")) {
				text = text.replace(",", "");
			}
			GuiHelper.playClickSound();
			
		}
		
		if(p_96552_ == 28 && textFocused && ModUtils.stringExist(text)) { //enter
			addText();
			GuiHelper.playClickSound();
			
		}else if(KeyHelper.isSelectAll(p_96552_) && ModUtils.stringExist(text)) { //select all
			selectText = true;
			
		}else if(KeyHelper.isCopy(p_96552_) && ModUtils.stringExist(text) && selectText) { //copy selected
			UniqueItemSettingScreen.setClipboard(text);
			
		}else if(KeyHelper.isCut(p_96552_) && ModUtils.stringExist(text)) { //cut selected
			UniqueItemSettingScreen.setClipboard(text);
			text = "";
			
		}else if(KeyHelper.isPaste(p_96552_)) { //cut selected
			if(selectText) {
				text = UniqueItemSettingScreen.getClipboard();
			}else {
				text += UniqueItemSettingScreen.getClipboard();
			}
		}else {
			if(selectText && ModUtils.stringExist(text)) {
				text = "";
			}
			if(ModUtils.stringExist(text) && textFocused) {
				if(p_96552_ == Keyboard.KEY_BACK || p_96552_ == Keyboard.KEY_DELETE) { //backspace -> delete
					if(selectText) {
						this.text = "";
					}else {
						this.text = text.substring(0, text.length() - 1);
						
					}
					GuiHelper.playClickSound();
				}
			}else {
				if(p_96552_ == KeyHandler.OPEN_SCREEN.func_151463_i() && !textFocused) {
					close();
					Minecraft.func_71410_x().func_147108_a(new DetailedSettingsScreen(DetailedSettingsScreen.selectedScreen));
				}
			}
			selectText = false;
		}
		super.func_73869_a(p_96553_, p_96552_);
	}
	
//////////////////////////////////////////render functions////////////////////////////////////////////////////////////////////////////////////////////////////////////
	@Override
	public void func_73863_a(int p_281550_, int p_282878_, float p_282465_) {
		GlStateManager.func_179094_E();
		this.func_73733_a(0, 0, this.field_146294_l, this.field_146295_m, -1072689136, -804253680);
		ITextComponent type = new TextComponentTranslation(WeaponMasterMod.MODID+".screen.blacklist");
		if(textType == 0) {
			type = new TextComponentTranslation(WeaponMasterMod.MODID+".screen.whitelist");
		}
		
		GuiHelper.drawString(field_146289_q, type, (int) ((field_146294_l/2)) - field_146289_q.func_78256_a(type.func_150254_d())/2, 10, Integer.parseInt("ffffff", 16), false);  
		
		type = new TextComponentString(text);
		int posx = ((field_146294_l/2) -5) - field_146289_q.func_78256_a(type.func_150254_d())/2;
		int posy = 25;
		
		if(selectText) {
			this.func_73733_a(posx + 5, posy, posx + field_146289_q.func_78256_a(type.func_150254_d()) + 5, posy + 20, -1072689136, -804253680);
		}
		this.func_73733_a(posx, posy, posx + field_146289_q.func_78256_a(type.func_150254_d()) + 10, posy + 20, -1072689136 * (textFocused? -1: 1), -804253680 * (textFocused? -1: 1));

		GuiHelper.drawString(field_146289_q, type, ((field_146294_l/2)) - field_146289_q.func_78256_a(type.func_150254_d())/2, posy + 5, Integer.parseInt("ffffff", 16), false);  

		//text from config
		if(ModUtils.stringContains(textFromConfig, ",")) {
			String[] txtArray = textFromConfig.split(",");
			
			int line = 0;
			int maxposy = field_146295_m/20;
			
			for(int i = hoverValue; i < txtArray.length; i++) { //hoverValue
				if(i+1 > (maxposy * 2)+1+hoverValue) {
					break;
				}
				if(ModUtils.stringEquals(txtArray[i], "empty")) {
					continue;
				}else {
					posx = (line + 1 > maxposy ? field_146294_l - field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()) - 5 : 5);
					posy = (line*20) + 5 - (line + 1 > maxposy ? maxposy * 20 : 0);
					
					this.func_73734_a(posx - 3, posy - 4, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()), posy+12, FastColor.ARGB32.color(255, 18, 3, 19));
					this.func_73734_a(posx - 4, posy - 3, 4 + posx + field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 18, 3, 19));
					this.func_73734_a(posx - 3, posy - 3, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 37, 2, 93));
					this.func_73734_a(posx - 2, posy - 2, 2 + posx + field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()), posy+10, FastColor.ARGB32.color(255, 18, 3, 19));
					
					
					GuiHelper.drawString(field_146289_q, txtArray[i], posx, posy, Integer.parseInt("ffffff", 16), false);  

					line++;
				}
			}
			
			//draw down arrow
			if(txtArray.length > maxposy * 2) {
				String s = new TextComponentTranslation(WeaponMasterMod.MODID+".screen.shiftscroll").func_150254_d();
				int tempx = field_146294_l/2 - field_146289_q.func_78256_a(s) / 2;
				int tempy = field_146295_m - 11;
//				int startheight = 12;
//				int endheight = 18;
//				int startwidth = 4;
//				int step = 4;
				
//				for(int j = 0; j < 3; j++) {
//					int color = FastColor.ARGB32.color(255, 18, 3, 19);
//					
//					if(j == 1) {
//						color = FastColor.ARGB32.color(255, 37, 2, 93);
//					}
//					
//					for(int i = 0; i <= endheight * 2; i++) {
//						if(i >= endheight) {
//							int newi = endheight * 2 - i;
//							p_281549_.drawRect(width/2 - startwidth - (newi-j) * step, tempy + i-1 - startheight, width/2 + startwidth + (newi-j) * step, tempy+i-startheight, color);
//							
//						}else {
//							p_281549_.drawRect(width/2 - startwidth - (i-j) * step, tempy + i-1 - startheight, width/2 + startwidth + (i-j) * step, tempy+i-startheight, color);
//							
//						}
//					}
//				}
				
				this.func_73734_a(tempx - 3, tempy - 4, 3 + tempx + field_146289_q.func_78256_a(new TextComponentString(s).func_150254_d()), tempy+12, FastColor.ARGB32.color(255, 18, 3, 19));
				GuiHelper.drawString(field_146289_q, s, tempx, tempy, Integer.parseInt("ffffff", 16), false);
			}
				
		}else if(ModUtils.stringExist(textFromConfig)) {
			posx = 5;
			posy = 5;
			
			if(!ModUtils.stringEquals(textFromConfig, "empty")) {
				this.func_73734_a(posx - 3, posy - 4, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(textFromConfig).func_150254_d()), posy+12, FastColor.ARGB32.color(255, 18, 3, 19));
				this.func_73734_a(posx - 4, posy - 3, 4 + posx + field_146289_q.func_78256_a(new TextComponentString(textFromConfig).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 18, 3, 19));
				this.func_73734_a(posx - 3, posy - 3, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(textFromConfig).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 37, 2, 93));
				this.func_73734_a(posx - 2, posy - 2, 2 + posx + field_146289_q.func_78256_a(new TextComponentString(textFromConfig).func_150254_d()), posy+10, FastColor.ARGB32.color(255, 18, 3, 19));
				GuiHelper.drawString(field_146289_q, textFromConfig, posx, posy, Integer.parseInt("ffffff", 16), false);  
			}
		}
		
		super.func_73863_a(p_281550_, p_282878_, p_282465_);
		
		normalbuttons.func_146112_a(Minecraft.func_71410_x(), p_281550_, p_282878_);
		
		WeaponMasterScreen.renderEntityInInventory(field_146294_l/2, field_146295_m/2 , 60 + DetailedSettingsScreen.scale, 0, 0, Minecraft.func_71410_x().field_71439_g);
		GlStateManager.func_179121_F();
	}
	
	public void renderBackground(int p_299421_, int p_298679_, float p_297268_) {}
	
	@Override
	public void func_146281_b() {
		//save
//		Helper.setTextList(textType);
		if(textType == 0) { //whitelist
			if(ModUtils.stringExist( ClientOnlyForgeSetup.whitelist)) {
				ConfigHelper.set("whitelist", ConfigHelper.whitelist = ClientOnlyForgeSetup.whitelist);
			}else {
				ClientOnlyForgeSetup.whitelist = "empty";
				ConfigHelper.set("whitelist", ConfigHelper.whitelist = "empty");
			}
			
		}else if(textType == 1) { //blacklist
			if(ModUtils.stringExist(ClientOnlyForgeSetup.blacklist)) {
				ConfigHelper.set("blacklist", ConfigHelper.blacklist = ClientOnlyForgeSetup.blacklist);
			}else {
				ClientOnlyForgeSetup.blacklist = "empty";
				ConfigHelper.set("blacklist", ConfigHelper.blacklist = "empty");
			}
		}
		
		close();
		super.func_146281_b();
	}
	
	public void close() {
		saveAllData();
	}
	
//////////////////////////////////////////mouse functions////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public boolean isMouseOverArea(double mouseX, double mouseY, int posX, int posY, int sizeX, int sizeY) {
		return (mouseX >= posX && mouseX < posX + sizeX && mouseY >= posY && mouseY < posY + sizeY);
	}

	@Override
	protected void func_73864_a(int p_94695_, int p_94696_, int p_94697_) throws IOException {
		ITextComponent type = new TextComponentString(text);
		int posx = ((field_146294_l/2) -5) - field_146289_q.func_78256_a(type.func_150254_d())/2;
		int posy = 25;
		
//text from config
		if(ModUtils.stringContains(textFromConfig, ",")) {
			String[] txtArray = textFromConfig.split(",");
			
			int line = 0;
			int maxposy = field_146295_m/20;
			
			for(int i = hoverValue; i < txtArray.length; i++) {
				if(i+1 > (maxposy * 2)+1+hoverValue) {
					break;
				}
				
				if(ModUtils.stringEquals(txtArray[i], "empty")) {
					continue;
				}else {
					
					int tempposx = (line + 1 > maxposy ? field_146294_l - field_146289_q.func_78256_a(new TextComponentString(txtArray[i]).func_150254_d()) - 8 : 1);
					int tempposy = (line*20) + 1 - (line + 1 > maxposy ? maxposy * 20 : 0);
					
					if(!ModUtils.stringEquals(txtArray[i], "empty") && !ModUtils.stringEquals(textFromConfig, "empty")) {
						if(isMouseOverArea(p_94695_, p_94696_, tempposx, tempposy, field_146289_q.func_78256_a(txtArray[i]) + 8, 17)) {
							//remove text
							
							String newtxt = "";
							for(int j = 0; j < txtArray.length; j++) {
								String txt = txtArray[j];
								if(!ModUtils.stringExist(newtxt)) {
									if(!ModUtils.stringEquals(txt, txtArray[i]) && ModUtils.stringExist(txt)) {
										newtxt += txt;
									}
								}else {
									if(!ModUtils.stringEquals(txt, txtArray[i]) && ModUtils.stringExist(txt)) {
										newtxt += ","+txt;
									}
								}
							}
							
							try {
							if(textType == 0) { //whitelist
								ClientOnlyForgeSetup.whitelist = newtxt;
								textFromConfig = newtxt;
								
							}else if(textType == 1) { //blacklist
								ClientOnlyForgeSetup.blacklist = newtxt;
								textFromConfig = newtxt;
							}

							saveAllData();
							}catch (Exception e) {}
							GuiHelper.playClickSound();
						}
					}
					line++;
				}
			}
		}else if(ModUtils.stringExist(textFromConfig)) {
			int tempposx = 1;
			int tempposy = 1;
			
			if(isMouseOverArea(p_94695_, p_94696_, tempposx, tempposy, field_146289_q.func_78256_a(textFromConfig) + 8, 17) && !ModUtils.stringEquals(textFromConfig, "empty")) {
				//remove text
				try {
					if(textType == 0) { //whitelist
						ClientOnlyForgeSetup.whitelist = ClientOnlyForgeSetup.whitelist.replace(textFromConfig, "empty");
						textFromConfig = ClientOnlyForgeSetup.whitelist;
						
					}else if(textType == 1) { //blacklist
						ClientOnlyForgeSetup.blacklist = ClientOnlyForgeSetup.blacklist.replace(textFromConfig, "empty");
						textFromConfig = ClientOnlyForgeSetup.blacklist;
					}

				}catch (Exception e) {}
				GuiHelper.playClickSound();
			}
		}
		
		if(isMouseOverArea(p_94695_, p_94696_, posx, posy, field_146289_q.func_78256_a(type.func_150254_d()) + 10, 20)) {
			textFocused = true;
			GuiHelper.playClickSound();
			
		}else {
			textFocused = false;
			selectText = false;
		}
		
		if(isMouseOverArea(p_94695_, p_94696_, 0, 0, field_146294_l, field_146295_m)) {
			this.draggingPlayerMode = true;
			ClientOnlyForgeSetup.xPos = (int) Math.floor(p_94695_);
			ClientOnlyForgeSetup.yPos = (int) Math.floor(p_94696_);
			ClientOnlyForgeSetup.fakexRot = ClientOnlyForgeSetup.xRot;
			ClientOnlyForgeSetup.fakeyRot = ClientOnlyForgeSetup.yRot;
		}
		
		super.func_73864_a(p_94695_, p_94696_, p_94697_);
	}
	
	@Override
	protected void func_146286_b(int p_94722_, int p_94723_, int p_94724_) {
		if(this.draggingPlayerMode) {
			this.draggingPlayerMode = false;
		}
		if(shiftDown) {
			shiftDown = false;
		}
		super.func_146286_b(p_94722_, p_94723_, p_94724_);
	}
	
	@Override
	public void func_146274_d() throws IOException {
		super.func_146274_d();
		int p_94689_ = Integer.signum(Mouse.getEventDWheel());
		
		if(!KeyHelper.hasShiftDown()) {
			if(p_94689_ < 0 && p_94689_ + DetailedSettingsScreen.scale < -60) {
				DetailedSettingsScreen.scale = -60;
			}else if(p_94689_ > 0 && p_94689_ + DetailedSettingsScreen.scale > 160) {
				DetailedSettingsScreen.scale = 160;
			}else {
				DetailedSettingsScreen.scale += p_94689_*2;
			}
		}else {
			if(ModUtils.stringContains(textFromConfig, ",")) {
				String[] txtArray = textFromConfig.split(",");
				
				if(hoverValue + p_94689_*-1 > 0 && hoverValue + p_94689_*-1 + ((field_146295_m/20) *2) <= txtArray.length) {
					hoverValue += p_94689_*-1;
				}else if(hoverValue + p_94689_*-1 + ((field_146295_m/20) *2) > txtArray.length){
					hoverValue = txtArray.length - ((field_146295_m/20) *2) < 0 ? 0 : txtArray.length - ((field_146295_m/20) *2);
				}
			}
		}
	}
	
	@Override
	protected void func_146273_a(int mouseX, int mouseY, int clickedMouseButton, long timeSinceLastClick) {
		if(this.draggingPlayerMode) {
			ClientOnlyForgeSetup.xRot = ClientOnlyForgeSetup.fakexRot - (int) (mouseX - ClientOnlyForgeSetup.xPos);
			ClientOnlyForgeSetup.yRot = ClientOnlyForgeSetup.fakeyRot - (int) (mouseY - ClientOnlyForgeSetup.yPos);
			
			if(ClientOnlyForgeSetup.xRot >= 360) {
				ClientOnlyForgeSetup.xRot -= 360;
			}else if(ClientOnlyForgeSetup.xRot <= -360) {
				ClientOnlyForgeSetup.xRot += 360;
			}
			if(ClientOnlyForgeSetup.yRot >= 360) {
				ClientOnlyForgeSetup.yRot -= 360;
			}else if(ClientOnlyForgeSetup.yRot <= -360) {
				ClientOnlyForgeSetup.yRot += 360;
			}
		}
		super.func_146273_a(mouseX, mouseY, clickedMouseButton, timeSinceLastClick);
	}
}
