package com.minecraftserverzone.weaponmaster.gui;

import java.io.IOException;

import org.lwjgl.input.Mouse;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.gui.normalbutton.Button;
import com.minecraftserverzone.weaponmaster.gui.togglebutton.ToggleButton;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.server.GetServerConfigSettingsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.ToggleSPacket;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.TextComponentTranslation;

public class WeaponMasterScreen extends GuiScreen{
	public static final ResourceLocation BG = new ResourceLocation(WeaponMasterMod.MODID, "textures/gui/gui_page_version.png");
	public boolean draggingPlayerMode = false;
	private ToggleButton[] slotbuttons = new ToggleButton[14];
	private Button[] normalbuttons = new Button[2];
	
	public WeaponMasterScreen() {
	}

	@Override
	public void func_73866_w_() {
		boolean[] toggleSlots = {
				ConfigHelper.TOGGLE_SLOT_MODEL[0],
				ConfigHelper.TOGGLE_SLOT_MODEL[1],
				ConfigHelper.TOGGLE_SLOT_MODEL[2],
				ConfigHelper.TOGGLE_SLOT_MODEL[3],
				ConfigHelper.TOGGLE_SLOT_MODEL[4],
				ConfigHelper.TOGGLE_SLOT_MODEL[5],
				ConfigHelper.TOGGLE_SLOT_MODEL[6],
				ConfigHelper.TOGGLE_SLOT_MODEL[7],
				ConfigHelper.TOGGLE_SLOT_MODEL[8],
				ConfigHelper.TOGGLE_SLOT_MODEL[9],
				ConfigHelper.TOGGLE_SLOT_MODEL[10],
				ConfigHelper.TOGGLE_SLOT_MODEL[11],
				ConfigHelper.TOGGLE_SLOT_MODEL[12],
				ConfigHelper.TOGGLE_SLOT_MODEL[13]
		};
		//on off
		for(int i = 0; i < 9; i++) {
			final int slot = i;
			this.field_146292_n.add(slotbuttons[i] = (new ToggleButton(this.field_146294_l / 2 - 111 + (slot * 16), this.field_146295_m / 2 - 50, 16, 20, new TextComponentTranslation(String.valueOf(slot+1)), (p_96337_) -> {
				changeData(slot); p_96337_.toggle = !p_96337_.toggle;
			}, toggleSlots[slot], 0)));
		}
		
		//shield
		this.field_146292_n.add(slotbuttons[9] = (new ToggleButton(this.field_146294_l / 2 - 111, this.field_146295_m / 2 - 30, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.shield").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.shield"), (p_96337_) -> {
			changeData(9); p_96337_.toggle = !p_96337_.toggle;
		}, toggleSlots[9], 0)));
		
		//banner
		this.field_146292_n.add(slotbuttons[10] = (new ToggleButton(this.field_146294_l / 2 - 111 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.shield").func_150254_d()) + 10, this.field_146295_m / 2 - 30, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.banner").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.banner"), (p_96337_) -> {
			changeData(10); p_96337_.toggle = !p_96337_.toggle;
		}, toggleSlots[10], 0)));
		

		//main hand
		this.field_146292_n.add(slotbuttons[11] = (new ToggleButton(this.field_146294_l / 2 - 111, this.field_146295_m / 2 - 10, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.mainhand").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.mainhand"), (p_96337_) -> {
			changeData(11); p_96337_.toggle = !p_96337_.toggle;
		}, toggleSlots[11], 0)));
		
		//off hand
		this.field_146292_n.add(slotbuttons[12] = (new ToggleButton(this.field_146294_l / 2 - 111 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.mainhand").func_150254_d()) + 10, this.field_146295_m / 2 - 10, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.offhand").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.offhand"), (p_96337_) -> {
			changeData(12); p_96337_.toggle = !p_96337_.toggle;
		}, toggleSlots[12], 0)));
		

		//quiver
		this.field_146292_n.add(slotbuttons[13] = (new ToggleButton(this.field_146294_l / 2 - 111 + (0 * 50), this.field_146295_m / 2 + 10, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.quiver").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.quiver"), (p_96337_) -> {
			changeData(13); p_96337_.toggle = !p_96337_.toggle;
		}, toggleSlots[13], 0)));
		
		
		this.field_146292_n.add(normalbuttons[0] = (new Button(this.field_146294_l / 2 - 20, this.field_146295_m / 2 + 62, 45, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.other_settings"), (p_96337_) -> {
			Minecraft.func_71410_x().func_147108_a(new DetailedSettingsScreen(DetailedSettingsScreen.selectedScreen));
		})));
		
		this.field_146292_n.add(normalbuttons[1] = new Button(this.field_146294_l / 2 - 111, this.field_146295_m / 2 + 35, field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.copy_server_settings").func_150254_d()) + 10, 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.copy_server_settings"), (p_96337_) -> {
			copyServerSettings();
		}));
		super.func_73866_w_();
	}

	public void copyServerSettings() {
		if(WeaponMasterMod.isMultiplayer) {
			Networking.sendToServer(new GetServerConfigSettingsSPacket());
		}
	}

	public void changeData(int slot) {
		try {
			String name = "s"+String.valueOf(slot);
				
				if(slot == 9) {
					name = "shield";
				}else if(slot == 10) {
					name = "banner";
				}else if(slot == 11) {
					name = "main_hand";
				}else if(slot == 12) {
					name = "off_hand";
				}else if(slot == 13) {
					name = "quiver";
				}
				

		;
		ConfigHelper.set(name, ConfigHelper.TOGGLE_SLOT_MODEL[slot] = !ConfigHelper.TOGGLE_SLOT_MODEL[slot]);

//		if(ConfigHelper.TOGGLE_SLOT_MODEL[slot]) {
//			ConfigHelper.TOGGLE_SLOT_MODEL[slot] = !ConfigHelper.TOGGLE_SLOT_MODEL[slot];
//			ConfigHelper.set(name, false);
//		}else {
//			ConfigHelper.set(name, true);
//		}
		
		int[] toggleSlots = {
		ConfigHelper.TOGGLE_SLOT_MODEL[0] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[1] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[2] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[3] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[4] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[5] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[6] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[7] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[8] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[9] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[10] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[11] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[12] ? 1 : 0,
		ConfigHelper.TOGGLE_SLOT_MODEL[13] ? 1 : 0
		};
		if(WeaponMasterMod.isMultiplayer) {
			Networking.sendToServer(new ToggleSPacket(toggleSlots));
		}
		
		}catch (Exception e) {}
	}

	public void renderBackground(int p_299421_, int p_298679_, float p_297268_) {
//		super.renderBackground(p_283688_, p_299421_, p_298679_, p_297268_);
	}
	
	@Override
	public void func_73863_a(int p_96563_, int p_96564_, float p_96565_) {
		int screenHeight = this.field_146295_m;
		int screenWidth =  this.field_146294_l;
	   	GlStateManager.func_179094_E();
//	   		RenderSystem.setShaderTexture(0, BG);
	   	GuiHelper.blit(this, BG, screenWidth/2 - (238/2), screenHeight/2 - (184/2), 0, 0, 238, 184);
	   	GuiHelper.drawString(field_146289_q, "YDM's Weapon Master", (int) ((screenWidth/2)) -field_146289_q.func_78256_a("YDM's Weapon Master") /2, ((screenHeight/2) - 80), Integer.parseInt("ffffff", 16), false);  
	  	GuiHelper.drawString(field_146289_q, "Turn ON/OFF Model Slot:", (int) ((screenWidth/2)) - 110, ((screenHeight/2) - 65), Integer.parseInt("ffffff", 16), false);  

	    renderEntityInInventory(screenWidth/2 + 70, screenHeight/2 , 60 + DetailedSettingsScreen.scale, 0, 0, Minecraft.func_71410_x().field_71439_g);
			
	    GlStateManager.func_179121_F();

		super.func_73863_a(p_96563_, p_96564_, p_96565_);
		
		for(int i = 0; i < slotbuttons.length; i++) {
			if(i == 11 || i == 12) {
				slotbuttons[i].visible = false;
			}else {
				slotbuttons[i].func_146112_a(Minecraft.func_71410_x(), p_96563_, p_96564_);
			}
		}
		
		for(int i = 0; i < normalbuttons.length; i++) {
			if((i == 1 && !WeaponMasterMod.isMultiplayer)) {
				normalbuttons[i].visible = false;
			}else {
				normalbuttons[i].func_146112_a(Minecraft.func_71410_x(), p_96563_, p_96564_);
			}
		}
	}
	
	@Override
	public void func_146281_b() {
		close();
		super.func_146281_b();
	}
	
	public void close() {
	}
	
	@Override
	public void func_73869_a(char p_96552_, int p_96553_) throws IOException {
		if(p_96553_ == KeyHandler.OPEN_SCREEN.func_151463_i()) {
			close();
//			Minecraft.getMinecraft().displayGuiScreen(new WeaponMasterScreen());
		}
		super.func_73869_a(p_96552_, p_96553_);
	}
	
	public static void renderEntityInInventory(int posX, int posY, int scale, float mouseX, float mouseY, EntityLivingBase ent) {
		float x = (float)Math.atan((double)(mouseX / 40.0F));
	  	float x1 = (float)Math.atan((double)(mouseY / 40.0F));  
		  
		GlStateManager.func_179142_g();
	      GlStateManager.func_179094_E();
	      GlStateManager.func_179109_b((float)posX, (float)posY, 50.0F);
	      GlStateManager.func_179152_a((float)(-scale), (float)scale, (float)scale);
	      GlStateManager.func_179114_b(180.0F, 0.0F, 0.0F, 1.0F);
	      GlStateManager.func_179114_b(-ClientOnlyForgeSetup.yRot - x1 * 20.0F, 1.0F, 0.0F, 0.0F);
	      
	      float f = ent.field_70761_aq;
	      float f1 = ent.field_70177_z;
	      float f2 = ent.field_70125_A;
	      float f3 = ent.field_70758_at;
	      float f4 = ent.field_70759_as;
	      GlStateManager.func_179114_b(135.0F, 0.0F, 1.0F, 0.0F);
	      RenderHelper.func_74519_b();
	      GlStateManager.func_179114_b(-135.0F, 0.0F, 1.0F, 0.0F);
	      GlStateManager.func_179114_b(-((float)Math.atan((double)(mouseY / 40.0F))) * 20.0F, 1.0F, 0.0F, 0.0F);
	      ent.field_70761_aq = ClientOnlyForgeSetup.xRot + x * 20.0F;
	      ent.field_70177_z = ClientOnlyForgeSetup.xRot + x * 40.0F;
	      ent.field_70125_A = -((float)Math.atan((double)(mouseY / 40.0F))) * 20.0F;
	      ent.field_70759_as = ent.field_70177_z;
	      ent.field_70758_at = ent.field_70177_z;

	      GlStateManager.func_179137_b(0.0D, -0.9D, 0.0D);
	      
	      RenderManager rendermanager = Minecraft.func_71410_x().func_175598_ae();
	      rendermanager.func_178631_a(180.0F);
	      rendermanager.func_178633_a(false);
	      rendermanager.func_188391_a(ent, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F, false);
	      rendermanager.func_178633_a(true);
	      ent.field_70761_aq = f;
	      ent.field_70177_z = f1;
	      ent.field_70125_A = f2;
	      ent.field_70758_at = f3;
	      ent.field_70759_as = f4;
	      GlStateManager.func_179121_F();
	        RenderHelper.func_74518_a();
	        GlStateManager.func_179101_C();
	        GlStateManager.func_179138_g(OpenGlHelper.field_77476_b);
	        GlStateManager.func_179090_x();
	        GlStateManager.func_179138_g(OpenGlHelper.field_77478_a);
	   }
	
	@Override
	protected void func_146273_a(int mouseX, int mouseY, int clickedMouseButton, long timeSinceLastClick) {
		if(this.draggingPlayerMode) {
			ClientOnlyForgeSetup.xRot = ClientOnlyForgeSetup.fakexRot - (int) (mouseX - ClientOnlyForgeSetup.xPos);
			ClientOnlyForgeSetup.yRot = ClientOnlyForgeSetup.fakeyRot - (int) (mouseY - ClientOnlyForgeSetup.yPos);
			
			if(ClientOnlyForgeSetup.xRot >= 360) {
				ClientOnlyForgeSetup.xRot -= 360;
			}else if(ClientOnlyForgeSetup.xRot <= -360) {
				ClientOnlyForgeSetup.xRot += 360;
			}
			if(ClientOnlyForgeSetup.yRot >= 360) {
				ClientOnlyForgeSetup.yRot -= 360;
			}else if(ClientOnlyForgeSetup.yRot <= -360) {
				ClientOnlyForgeSetup.yRot += 360;
			}
		}
		super.func_146273_a(mouseX, mouseY, clickedMouseButton, timeSinceLastClick);
	}
	
	@Override
	public void func_146274_d() throws IOException {
		super.func_146274_d();
		int p_94689_ = Integer.signum(Mouse.getEventDWheel());
		
		if(p_94689_ < 0 && p_94689_ + DetailedSettingsScreen.scale < -60) {
			DetailedSettingsScreen.scale = -60;
		}else if(p_94689_ > 0 && p_94689_ + DetailedSettingsScreen.scale > 160) {
			DetailedSettingsScreen.scale = 160;
		}else {
			DetailedSettingsScreen.scale += p_94689_*2;
		}
	}
	
	@Override
	protected void func_73864_a(int p_94695_, int p_94696_, int p_94697_) throws IOException {
		int screenHeight = this.field_146295_m;
		int screenWidth =  this.field_146294_l;
		if(isMouseOverArea(p_94695_, p_94696_, screenWidth/2 + 10, screenHeight/2 - 60, 115, 125)) {
			this.draggingPlayerMode = true;
			ClientOnlyForgeSetup.xPos = (int) Math.floor(p_94695_);
			ClientOnlyForgeSetup.yPos = (int) Math.floor(p_94696_);
			ClientOnlyForgeSetup.fakexRot = ClientOnlyForgeSetup.xRot;
			ClientOnlyForgeSetup.fakeyRot = ClientOnlyForgeSetup.yRot;
		}
		
		super.func_73864_a(p_94695_, p_94696_, p_94697_);
	}
	
	@Override
	protected void func_146286_b(int p_94722_, int p_94723_, int p_94724_) {
		if(this.draggingPlayerMode) {
			this.draggingPlayerMode = false;
		}
		super.func_146286_b(p_94722_, p_94723_, p_94724_);
	}
	
	private boolean isMouseOverArea(double mouseX, double mouseY, int posX, int posY, int sizeX, int sizeY) {
		return (mouseX >= posX && mouseX < posX + sizeX && mouseY >= posY && mouseY < posY + sizeY);
	}
}
