package com.minecraftserverzone.weaponmaster.gui.slider;

import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;

import net.minecraft.client.Minecraft;
import net.minecraft.client.audio.SoundHandler;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.text.ITextComponent;

public abstract class NewAbstractSlider extends NewAbstractWidget {
   public double value;

   public NewAbstractSlider(int p_93579_, int p_93580_, int p_93581_, int p_93582_, ITextComponent p_93583_, double p_93584_) {
      super(p_93579_, p_93580_, p_93581_, p_93582_, p_93583_);
      this.value = p_93584_;
   }

   protected int getYImage(boolean p_93607_) {
      return 0;
   }
   
   protected void renderBg(int p_93602_, int p_93603_) {
//      RenderSystem.setShaderTexture(0, WIDGETS_LOCATION);
      GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
      int i = (this.isHoveredOrFocused() ? 2 : 1) * 20;
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + (int)(this.value * (double)(this.width - 8)), this.y, 0, 46 + i, 4, 7);
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + (int)(this.value * (double)(this.width - 8)), this.y + 6, 0, 59 + i, 4, 7);
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + (int)(this.value * (double)(this.width - 8)) + 4, this.y, 196, 46 + i, 4, 7);
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + (int)(this.value * (double)(this.width - 8)) + 4, this.y + 6, 196, 59 + i, 4, 7);
   }

   @Override
   public void onClick(int p_93588_, int p_93589_) {
	   super.onClick(p_93588_, p_93589_);
	   this.setValueFromMouse(p_93588_);
   }

   public boolean keyPressed(int p_93596_, int p_93597_, int p_93598_) {
      boolean flag = p_93596_ == 263;
      if (flag || p_93596_ == 262) {
         float f = flag ? -1.0F : 1.0F;
         this.setValue(this.value + (double)(f / (float)(this.width - 8)));
      }
      
      return false;
   }

   private void setValueFromMouse(double p_93586_) {
      this.setValue((p_93586_ - (double)(this.x + 4)) / (double)(this.width - 8));
   }

   private void setValue(double p_93612_) {
      double d0 = this.value;
      this.value = clamp(p_93612_, 0.0D, 1.0D);
      if (d0 != this.value) {
         this.applyValue();
      }

      this.updateMessage();
   }
   
   public static boolean equal(double p_219806_0_, double p_219806_2_) {
	      return Math.abs(p_219806_2_ - p_219806_0_) < (double)1.0E-5F;
	   }
   
   public static double clamp(double p_151237_0_, double p_151237_2_, double p_151237_4_) {
	      if (p_151237_0_ < p_151237_2_) {
	         return p_151237_2_;
	      } else {
	         return p_151237_0_ > p_151237_4_ ? p_151237_4_ : p_151237_0_;
	      }
	   }
   
   public static double lerp(double p_219803_0_, double p_219803_2_, double p_219803_4_) {
	      return p_219803_2_ + p_219803_0_ * (p_219803_4_ - p_219803_2_);
	   }

   public static double map(double p_144915_, double p_144916_, double p_144917_, double p_144918_, double p_144919_) {
	      return lerp(inverseLerp(p_144915_, p_144916_, p_144917_), p_144918_, p_144919_);
	   }
   
   public static double inverseLerp(double p_14113_, double p_14114_, double p_14115_) {
	      return (p_14113_ - p_14114_) / (p_14115_ - p_14114_);
	   }


   @Override
   protected void onDrag(Minecraft mc, int p_93591_, int p_93592_) {
	   super.onDrag(mc, p_93591_, p_93592_);
	   this.setValueFromMouse(p_93591_);
   }

   public void playDownSound(SoundHandler p_93605_) {
   }

   @Override
   public void onRelease(int p_93609_, int p_93610_) {
      super.onRelease(p_93609_, p_93610_);
   }

   protected abstract void updateMessage();

   protected abstract void applyValue();
}
