package com.minecraftserverzone.weaponmaster.gui.smallButton;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;

import net.minecraft.client.Minecraft;
import net.minecraft.client.audio.SoundHandler;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.text.ITextComponent;

public abstract class AbstractSmallWidget extends GuiButton {
   public static final ResourceLocation WIDGETS_LOCATION = new ResourceLocation(WeaponMasterMod.MODID, "textures/gui/widgets.png");
   protected int width;
   protected int height;
   public int x;
   public int y;
   private ITextComponent message;
   protected boolean isHovered;
   public boolean active = true;
   public boolean visible = true;
   protected float alpha = 1.0F;
   private boolean focused;
   public boolean toggle;
   public int buttonid = 0;

   public AbstractSmallWidget(int p_93629_, int p_93630_, int p_93631_, int p_93632_, ITextComponent p_93633_) {
	   super(WeaponMasterMod.buttonid++, p_93629_, p_93630_, p_93631_, p_93632_, p_93633_.func_150261_e());
      this.x = p_93629_;
      this.y = p_93630_;
      this.width = p_93631_;
      this.height = p_93632_;
      this.message = p_93633_;
      buttonid = WeaponMasterMod.buttonid;
      
   }

   public int getHeight() {
      return this.height;
   }

   protected int getYImage(boolean p_93668_) {
      int i = 1;
      if (!this.active) {
         i = 0;
      } else if (p_93668_) {
         i = 2;
      }

      return i;
   }

   @Override
   public void func_146112_a(Minecraft mc, int p_93658_, int p_93659_) {
      if (this.visible) {
         this.isHovered = p_93658_ >= this.x && p_93659_ >= this.y && p_93658_ < this.x + this.width && p_93659_ < this.y + this.height;
         this.renderButton(p_93658_, p_93659_, 0);
      }
   }
   
   public void renderButton(int p_93677_, int p_93678_, float p_93679_) {
      Minecraft minecraft = Minecraft.func_71410_x();
      FontRenderer font = minecraft.field_71466_p;
//      RenderSystem.setShader(GameRenderer::getPositionTexShader);
//      RenderSystem.setShaderTexture(0, WIDGETS_LOCATION);
      GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, this.alpha);
      int i = this.getYImage(this.isHoveredOrFocused());
      GlStateManager.func_179147_l();
      GlStateManager.func_187428_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);
      GlStateManager.func_187401_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
      
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x, this.y, 0, 46 + i * 20, this.width / 2, 6);
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + this.width / 2, this.y, 200 - this.width / 2, 46 + i * 20, this.width / 2, 6);
      
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x, this.y + 6, 0, 59 + i * 20, this.width / 2, 7);
      GuiHelper.blit(this, WIDGETS_LOCATION, this.x + this.width / 2, this.y + 6, 200 - this.width / 2, 59 + i * 20, this.width / 2, 7);
      
//      this.renderBg(p_93676_, minecraft, p_93677_, p_93678_);
      int j = getFGColor();
      this.func_73732_a(font, this.getMessage().func_150254_d(), this.x + this.width / 2, this.y + (this.height - 6) / 2, j | ServerHelper.ceil(this.alpha * 255.0F) << 24);
   }

   protected void renderBg(Minecraft p_93662_, int p_93663_, int p_93664_) {
   }

   @Override
   public boolean func_146116_c(Minecraft mc, int p_93641_, int p_93642_) {
      if (this.active && this.visible) {
            boolean flag = this.clicked(p_93641_, p_93642_);
            if (flag) {
               this.playDownSound(Minecraft.func_71410_x().func_147118_V());
               this.onClick(p_93641_, p_93642_);
               return true;
            }
      }
      return false;
   }

   @Override
   public void func_146118_a(int mouseX, int mouseY) {
         this.onRelease(mouseX, mouseY);
   }

   @Override
   protected void func_146119_b(Minecraft mc, int mouseX, int mouseY) {
         this.onDrag(mc, mouseX, mouseY);
   }

   public void onRelease(double p_93669_, double p_93670_) {
   }

   protected void onDrag(Minecraft mc, int mouseX, int mouseY) {
   }

   protected boolean clicked(double p_93681_, double p_93682_) {
      return this.active && this.visible && p_93681_ >= (double)this.x && p_93682_ >= (double)this.y && p_93681_ < (double)(this.x + this.width) && p_93682_ < (double)(this.y + this.height);
   }

   public boolean isHoveredOrFocused() {
      return this.isHovered || this.focused;
   }

   public boolean isMouseOver(double p_93672_, double p_93673_) {
      return this.active && this.visible && p_93672_ >= (double)this.x && p_93673_ >= (double)this.y && p_93672_ < (double)(this.x + this.width) && p_93673_ < (double)(this.y + this.height);
   }

   public void renderToolTip(int p_93654_, int p_93655_) {
   }

   public void playDownSound(SoundHandler p_93665_) {
//      p_93665_.playSound(PositionedSoundRecord.getMasterRecord(SoundEvents.UI_BUTTON_CLICK, 1.0F));
   }

   public int getWidth() {
      return this.width;
   }

   public void func_175211_a(int p_93675_) {
      this.width = p_93675_;
   }

   public void setHeight(int value) {
      this.height = value;
   }

   public void setAlpha(float p_93651_) {
      this.alpha = p_93651_;
   }

   public void setMessage(ITextComponent p_93667_) {
      this.message = p_93667_;
   }

   public ITextComponent getMessage() {
      return this.message;
   }

   public boolean isFocused() {
      return this.focused;
   }

   public boolean isActive() {
      return this.visible && this.active;
   }

   public void setFocused(boolean p_93693_) {
      this.focused = p_93693_;
   }

   public static final int UNSET_FG_COLOR = -1;
   protected int packedFGColor = UNSET_FG_COLOR;
   public int getFGColor() {
      if (packedFGColor != UNSET_FG_COLOR) return packedFGColor;
      return this.active ? 16777215 : 10526880; // White : Light Grey
   }
   public void setFGColor(int color) {
      this.packedFGColor = color;
   }
   public void clearFGColor() {
      this.packedFGColor = UNSET_FG_COLOR;
   }
   
   public abstract void onPress();

   public void onClick(double p_93371_, double p_93372_) {
      this.onPress();
   }

   public boolean keyPressed(int p_93374_, int p_93375_, int p_93376_) {
      if (this.active && this.visible) {
         if (p_93374_ != 257 && p_93374_ != 32 && p_93374_ != 335) {
            return false;
         } else {
            this.playDownSound(Minecraft.func_71410_x().func_147118_V());
            this.onPress();
            return true;
         }
      } else {
         return false;
      }
   }
}
