package com.minecraftserverzone.weaponmaster.gui.togglebutton;

import java.util.function.Consumer;

import net.minecraft.client.Minecraft;
import net.minecraft.util.text.ITextComponent;

public class ToggleButton extends AbstractToggleWidget {
   public static final ToggleButton.OnTooltip NO_TOOLTIP = (p_93741_, p_93742_, p_93743_) -> {
   };
   protected final ToggleButton.OnPress onPress;
   protected final ToggleButton.OnTooltip onTooltip;

   public ToggleButton(int p_93721_, int p_93722_, int p_93723_, int p_93724_, ITextComponent p_93725_, ToggleButton.OnPress p_93726_, boolean toggle, int visible) {
      this(p_93721_, p_93722_, p_93723_, p_93724_, p_93725_, p_93726_, NO_TOOLTIP, toggle, visible);
   }

   public ToggleButton(int p_93728_, int p_93729_, int p_93730_, int p_93731_, ITextComponent p_93732_, ToggleButton.OnPress p_93733_, ToggleButton.OnTooltip p_93734_, boolean toggle, int visible) {
      super(p_93728_, p_93729_, p_93730_, p_93731_, p_93732_, toggle, visible);
      this.onPress = p_93733_;
      this.onTooltip = p_93734_;
   }

   public void onPress() {
      this.onPress.onPress(this);
   }

   public void drawButton(Minecraft mc, int p_93747_, int p_93748_, float p_93749_) {
      super.func_146112_a(mc, p_93747_, p_93748_);
      if (this.isHoveredOrFocused()) {
         this.renderToolTip(p_93747_, p_93748_);
      }

   }

   public void renderToolTip(int p_93737_, int p_93738_) {
      this.onTooltip.onTooltip(this, p_93737_, p_93738_);
   }

   public interface OnPress {
      void onPress(ToggleButton p_93751_);
   }

   public interface OnTooltip {
      void onTooltip(ToggleButton p_93753_, int p_93755_, int p_93756_);

      default void narrateTooltip(Consumer<ITextComponent> p_168842_) {
      }
   }
   
	public void setX(int p_265236_) {
		this.x = p_265236_;
	}

	public void setY(int p_265404_) {
		this.y = p_265404_;
	}

	public int getX() {
		return this.x;
	}

	public int getY() {
		return this.y;
	}
}
