package com.minecraftserverzone.weaponmaster.itemlayers;

import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;

import com.google.common.collect.Maps;
import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.renderer.quiver.QuiverWithArrowsModel;
import com.minecraftserverzone.weaponmaster.setup.helper.ModUtils;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import net.minecraft.client.Minecraft;
import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms.TransformType;
import net.minecraft.client.renderer.entity.RenderLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemArrow;
import net.minecraft.item.ItemBanner;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemShield;
import net.minecraft.item.ItemSpectralArrow;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemSword;
import net.minecraft.item.ItemTool;
import net.minecraft.util.EnumHandSide;
import net.minecraft.util.ResourceLocation;

public class RenderHelper {
	public static final Map<String, QuiverWithArrowsModel<EntityPlayer>> quiverModels = Maps.newHashMap();
	public static final Map<String, QuiverWithArrowsModel<EntityPlayer>> arrowsModels = Maps.newHashMap();
	
	public static int[] uniqueSettings(ItemStack stack, int slotNumber, String txt) {
		String selectedSlotNumber = "0";
		
		if(slotNumber < 9) {
			selectedSlotNumber = String.valueOf(slotNumber+1);
		}else if(slotNumber == 9) {
			selectedSlotNumber = "shield";
		}else if(slotNumber == 10) {
			selectedSlotNumber = "banner";
		}else if(slotNumber == 11) {
			selectedSlotNumber = "offhand";
		}else if(slotNumber == 12) {
			selectedSlotNumber = "quiver";
		}

		if(stack != null) {
			if(stack.func_77973_b() != null) {
				if(ModUtils.stringContains(txt, ",")) {
					if(ModUtils.stringContains(txt, " ")) { //list
						String[] allData = txt.split(" ");
						
						for(int i = 0; i < allData.length; i++) {
							if(ModUtils.stringContains(allData[i], ",")) {
								String name = StringUtils.substringBefore(allData[i], ",");
								String[] data = allData[i].split(",");
								
								if(ModUtils.arrayExist(data, 9)) {
									String itemname = "";
									if(stack.func_77973_b() != null && ModUtils.stringExist(stack.func_77973_b().getRegistryName().func_110623_a())) {
										itemname = stack.func_77973_b().getRegistryName().func_110623_a();
										
										if(ModUtils.stringContains(itemname, ".")) {
											itemname = StringUtils.substringAfterLast(itemname, ".");
										}
									}
									
									if(ModUtils.stringExist(itemname) && itemname.equals(name)
											&& ModUtils.stringEquals(data[8], selectedSlotNumber)) {
										return getData(allData[i]);
									}
								}
							}
						}
						
					}else {
						String name = StringUtils.substringBefore(txt, ",");
						String[] data = txt.split(",");
						
						if(ModUtils.arrayExist(data, 9)) {
							String itemname = "";
							if(stack.func_77973_b() != null && ModUtils.stringExist(stack.func_77973_b().getRegistryName().func_110623_a())) {
								itemname = stack.func_77973_b().getRegistryName().func_110623_a();
								
								if(ModUtils.stringContains(itemname, ".")) {
									itemname = StringUtils.substringAfterLast(itemname, ".");
								}
							}
							
							if(ModUtils.stringExist(itemname) && itemname.equals(name)
									&& ModUtils.stringEquals(data[8], selectedSlotNumber)) {
								return getData(txt);
							}
						}
					}
				}
			}
		}
		
		return new int[] {0, 0, 0, 0, 0, 0, 0};
	}

	public static int[] getData(String s) {
		String[] txtArray = s.split(",");
		
		if(ModUtils.arrayExist(txtArray, 8)) {
			int x = 0;
			if(NumberUtils.isNumber(txtArray[1])) {
				x = NumberUtils.createInteger(txtArray[1]);
			}
			int y = 0;
			if(NumberUtils.isNumber(txtArray[2])) {
				y = NumberUtils.createInteger(txtArray[2]);
			}
			int z = 0;
			if(NumberUtils.isNumber(txtArray[3])) {
				z = NumberUtils.createInteger(txtArray[3]);
			}
			int xrot = 0;
			if(NumberUtils.isNumber(txtArray[4])) {
				xrot = NumberUtils.createInteger(txtArray[4]);
			}
			int yrot = 0;
			if(NumberUtils.isNumber(txtArray[5])) {
				yrot = NumberUtils.createInteger(txtArray[5]);
			}
			int zrot = 0;
			if(NumberUtils.isNumber(txtArray[6])) {
				zrot = NumberUtils.createInteger(txtArray[6]);
			}
			int scale = 0;
			if(NumberUtils.isNumber(txtArray[7])) {
				scale = NumberUtils.createInteger(txtArray[7]);
			}
					
			return new int[] {x, y, z, xrot, yrot, zrot, scale};
		}
		
		return new int[] {0, 0, 0, 0, 0, 0, 0};
	}
	
	public static boolean blackListed(ItemStack item, String txt) {
		   /** TODO create blacklist data for the capability */
			if(txt != null){
				if(item == null) {
					return false;
				}
				String[] blacklist = txt.split(",");
				for(String bl : blacklist){
					String itemname = "";
					if(item.func_77973_b() != null && ModUtils.stringExist(item.func_77973_b().getRegistryName().func_110623_a())) {
						itemname = item.func_77973_b().getRegistryName().func_110623_a();
						
						if(ModUtils.stringContains(itemname, ".")) {
							itemname = StringUtils.substringAfterLast(itemname, ".");
						}
					}
					if(ModUtils.stringEquals(itemname, bl)){
						return true;
					}
				}
			}
			return false;
	}
	   
	public static boolean whiteListed(ItemStack item, String txt){
			/** TODO create whitelist data for the capability */
			if(txt!=null){
				if(item == null) {
					return false;
				}

				String[] whitelist = txt.split(",");
				for(String wl : whitelist){
					String itemname = "";
					if(item.func_77973_b() != null && ModUtils.stringExist(item.func_77973_b().getRegistryName().func_110623_a())) {
						itemname = item.func_77973_b().getRegistryName().func_110623_a();
						
						if(ModUtils.stringContains(itemname, ".")) {
							itemname = StringUtils.substringAfterLast(itemname, ".");
						}
					}
					if(ModUtils.stringEquals(itemname, wl)){
						return true;
					}
				}
			}
			return false;
	}

	public static void move(String[][] moveTypes, int slot, float translation) {
		   if(moveTypes[slot][2].equals("-")) {
			   translation = -translation;
		   }
		   if(moveTypes[slot][1].equals("x")) {
			   GlStateManager.func_179109_b(translation, 0, 0);
		   }else if(moveTypes[slot][1].equals("y")) {
			   GlStateManager.func_179109_b(0, translation, 0);
		   }else if(moveTypes[slot][1].equals("z")) {
			   GlStateManager.func_179109_b(0, 0, translation);
		   }
	}
	
	public static int hasItems(ItemStack[] items, EntityPlayer player, String[][] moveTypes, int slot, int selected, int shieldSlot, int bannerSlot, int[] toggleSlots) {
		   int i = 0;
		   for(int j = 0; j < 9; j++) {
			   if(moveTypes[slot][0].contains(String.valueOf(j+1))) {
				   if(items[j] != null) {
					   if(!ServerHelper.isEmpty(items[j]) && selected != j && toggleSlots[j] == 1) { // not empty and not selected
						   i++;
					   }
				   }
			   }
		   }
		   
		   if(moveTypes[slot][0].contains("shield")) {
			   if(shieldSlot > -1 && selected != shieldSlot && toggleSlots[9] == 1) { // not empty and not selected
				   i++;
			   }
		   }
		   if(moveTypes[slot][0].contains("banner")) {
	
			   if(bannerSlot > -1 && selected != bannerSlot && toggleSlots[10] == 1) { // not empty and not selected
				   i++;
	
			   }
		   }
		   
		   if(moveTypes[slot][0].contains("quiver")) {
			   for(int j = 0; j < 9; j++) {
				   if(ServerHelper.getProjectile(player, items[j]) != null) {
					   if(ServerHelper.getProjectile(player, items[j]).func_77973_b() instanceof ItemArrow) {
						   if(!ServerHelper.isEmpty(items[j]) && toggleSlots[10] == 1) { // not empty and not selected
							   i++;
							   break;
						   }
					   }
				   }
			   }
		   }
		   
		   return i;
	}
	
	
	public static boolean hasEquipments(EntityPlayer player, String[][] moveTypes, int slot) {
		   boolean move = false;
	//	   FEET(EquipmentSlot.Type.ARMOR, 0, 1, "feet"),
	//	   LEGS(EquipmentSlot.Type.ARMOR, 1, 2, "legs"),
	//	   CHEST(EquipmentSlot.Type.ARMOR, 2, 3, "chest"),
	//	   HEAD(EquipmentSlot.Type.ARMOR, 3, 4, "head");
		   if(moveTypes[slot][0].contains("helm")) {
			   if(!ServerHelper.isEmpty(player.field_71071_by.func_70440_f(3))) {
				   move = true;
			   }
		   }
		   if(moveTypes[slot][0].contains("chest")) {
			   if(!ServerHelper.isEmpty(player.field_71071_by.func_70440_f(2))) {
				   move = true;
			   }
		   }
		   if(moveTypes[slot][0].contains("legs")) {
			   if(!ServerHelper.isEmpty(player.field_71071_by.func_70440_f(1))) {
				   move = true;
			   }
		   }
		   if(moveTypes[slot][0].contains("boots")) {
			   if(!ServerHelper.isEmpty(player.field_71071_by.func_70440_f(0))) {
				   move = true;
			   }
		   }
		   
		   return move;
	}

	public static void translateToHand(ModelRenderer part, EnumHandSide p_102854_, float p_102855_) {
		part.func_78794_c(p_102855_);
	}

//	public static void translateRotate(float x, float y, float z, float xRot, float yRot, float zRot, float xScale, float yScale, float zScale) {
//		GlStateManager.translate((double)(x / 16.0F), (double)(y / 16.0F), (double)(z / 16.0F));
//	      if (zRot != 0.0F) {
//	    	  GlStateManager.rotate(Vector3f.ZP.rotation(zRot));
//	      }
//
//	      if (yRot != 0.0F) {
//	    	  GlStateManager.rotate(Vector3f.YP.rotation(yRot));
//	      }
//
//	      if (xRot != 0.0F) {
//	    	  GlStateManager.rotate(Vector3f.XP.rotation(xRot));
//	      }
//
//	      if (xScale != 1.0F || yScale != 1.0F || zScale != 1.0F) {
//	    	  GlStateManager.scale(xScale, yScale, zScale);
//	      }
//	}
	
	public static void copyModelPartRotation(ModelBiped model, int slot, String[][] bodyattachment, float multiplier, float maxRotateChanger) {
		   ModelRenderer part = model.field_78115_e;
		   
	 	  if(bodyattachment[slot][1].equals("head")) {
	 		  part = model.field_78116_c;
	 	  }else if(bodyattachment[slot][1].equals("body")) {
	 		  part = model.field_78115_e;
	 	  }else if(bodyattachment[slot][1].equals("rarm")) {
	 		  part = model.field_178723_h;
	 	  }else if(bodyattachment[slot][1].equals("larm")) {
	 		  part = model.field_178724_i;
	 	  }else if(bodyattachment[slot][1].equals("rleg")) {
	 		  part = model.field_178721_j;
	 	  }else if(bodyattachment[slot][1].equals("lleg")) {
	 		  part = model.field_178722_k;
	 	  }
		   
	       part.func_78794_c(0.0625F);    
	   }

	//render other EntityPlayer in vanilla weaponmaster
	public static void renderOtherPlayerWithItems(RenderLivingBase modelrenderer, EntityPlayer player, ModelBiped model) {
		QuiverWithArrowsModel<EntityPlayer> quiver = null;
		QuiverWithArrowsModel<EntityPlayer> arrows = null;
		String playername = player.func_70005_c_();
		
		if(!quiverModels.containsKey(playername)) {
			quiverModels.put(playername, new QuiverWithArrowsModel(64, 64));
		
			quiver = quiverModels.get(playername);
		}else {
			quiver = quiverModels.get(playername);
		}
		
		if(!arrowsModels.containsKey(playername)) {
			arrowsModels.put(playername, new QuiverWithArrowsModel(64, 64));
		
			arrows = arrowsModels.get(playername);
		}else {
			arrows = arrowsModels.get(playername);
		}
		
		PlayerData data = ServerHelper.getPlayerData(player);
	 	  
		String uniqueItemSettings = data.uniqueItemDisplay;
		String whitelist = data.whitelist;
		
		String[] moveSlots = data.mover.split("_"); //divide to 12 slots
		String[][] moveTypes = {
						moveSlots[0].split(";"),
						moveSlots[1].split(";"),
						moveSlots[2].split(";"),
						moveSlots[3].split(";"),
						moveSlots[4].split(";"),
						moveSlots[5].split(";"),
						moveSlots[6].split(";"),
						moveSlots[7].split(";"),
						moveSlots[8].split(";"),
						moveSlots[9].split(";"),
						moveSlots[10].split(";"),
						moveSlots[11].split(";"),
						moveSlots[12].split(";")
					};

			   int selected = data.selectedSlot;

			   int num = 0;
			   ItemStack stack1 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num];  num++;
			   ItemStack stack2 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack3 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack4 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack5 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack6 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack7 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack8 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack stack9 = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack offhand = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num]; num++;
			   ItemStack ammo = blackListed(data.inventory[num], data.blacklist) ? ServerHelper.AIR_STACK : data.inventory[num] == null ? ServerHelper.AIR_STACK : data.inventory[num];
			   
			   ItemStack[] items = { stack1, stack2, stack3, stack4, stack5, stack6, stack7, stack8, stack9, offhand, ammo};	     
			   
//			   System.out.println(stack1);
			   
			   int[] toggleSlots = data.toggleSlots;
			   int[] slotPositions = data.positions;
			   int[] slotRotations = data.rotations;
			   int[] scale = data.scale;
			   
			   //attachments
			   String[] bodyattachments = data.slotAttachments.split(",");
			   String[][] bodyattachment = new String[WeaponMasterMod.maxDisplaySlotNum][2];
			   
			   for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
				   bodyattachment[i][0] = bodyattachments[i].split("-")[0];
				   bodyattachment[i][1] = bodyattachments[i].split("-")[1];
			   }
			      
			   if((data.lastMainhandHit >= data.hideTick && data.toggleSlots[11] == 1)) {
			    	  selected = -1;
			   }
			   
			  int shieldAt = -1;
			  shieldSearchLoop: {
		 	  for(int i = 0; i < 9; i++) {
		 		 if(items[i] != null) {
		 			if(items[i].func_77973_b() instanceof ItemShield) {
			 			  shieldAt = i;
			 			  break shieldSearchLoop;
			 		  }
		 		 }
		 	  }
		   }
		
		   int bannerAt = -1;
		   bannerSearchLoop: {
		 	  for(int i = 0; i < 9; i++) {
		 		 if(items[i] != null) {
		 			if(items[i].func_77973_b() instanceof ItemBanner) {
			 			  bannerAt = i;
			 			  break bannerSearchLoop;
			 		  }
		 		 }
		 	  }
		   }
		  //render banner if not in main hand
		   if(bannerAt != -1 && selected != bannerAt && toggleSlots[10] == 1){
		 	  GlStateManager.func_179094_E();
		 	  copyModelPartRotation(model, 10, bodyattachment, 0.01f, 1f);
		 	  
		 	  float moveBy2 = hasItems(items, player, moveTypes, 10, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
			      move(moveTypes, 10, moveBy2);
		 	  float moveBy = hasEquipments(player, moveTypes, 10) ? 0.038f : 0;
		 	  move(moveTypes, 10, moveBy);
			int[] add = uniqueSettings(items[bannerAt], 10, uniqueItemSettings);
		 	  
			GlStateManager.func_179109_b(((float)(slotPositions[30] + add[0])/100f), ((float)(slotPositions[31] + add[1])/100f), ((float)(slotPositions[32] + add[2])/100f));
			GlStateManager.func_179114_b(slotRotations[30] + add[3], 1, 0, 0);
			GlStateManager.func_179114_b(slotRotations[31] + add[4], 0, 1, 0);
			GlStateManager.func_179114_b(slotRotations[32] + add[5], 0, 0, 1);
		 	  
			GlStateManager.func_179114_b(180.0F, 0, 1, 0);
			GlStateManager.func_179114_b(180.0F, 0, 0, 1);
		 	 GlStateManager.func_179137_b(0.0F, 0.6D, -0.3D);
		 	  float scalePlus = (scale[10]+0.001f + add[6])/100;
		 	  float f = 0.75f;
		 	 GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
		       Minecraft.func_71410_x().func_175597_ag().func_187462_a(player, items[bannerAt], TransformType.NONE, false);
		       GlStateManager.func_179121_F();
		   }
		   
		   GlStateManager.func_179094_E();
		   //render shield if not in main hand
		   if(shieldAt != -1 && selected != shieldAt && toggleSlots[9] == 1){
			   GlStateManager.func_179094_E();
		 	  copyModelPartRotation(model, 9, bodyattachment, 1f, 1f);
		 	  
		 	  float moveBy2 = hasItems(items, player, moveTypes, 9, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
			      move(moveTypes, 9, moveBy2);
		 	  float moveBy = hasEquipments(player, moveTypes, 9)? 0.038f : 0;
		 	  move(moveTypes, 9, moveBy);
		 	  
		 	  int[] add = uniqueSettings(items[shieldAt], 9, uniqueItemSettings);
		 	  
		 	 GlStateManager.func_179109_b(((float)(slotPositions[27] + add[0])/100f), ((float)(slotPositions[28] + add[1])/100f), ((float)(slotPositions[29] + add[2])/100f));
		 	  
		 	GlStateManager.func_179137_b(0.0F, 0.0D, 0.015D);
		       
		 	GlStateManager.func_179114_b(slotRotations[27] + add[3], 1, 0, 0);
		 	GlStateManager.func_179114_b(slotRotations[28] + add[4], 0, 1, 0);
		 	GlStateManager.func_179114_b(slotRotations[29] + add[5], 0, 0, 1);
			      
		 	GlStateManager.func_179137_b(0.3F, 0.7D, 0.5D);
		//       p_174521_.scale(0.6f, 0.6f, 0.6f);
		
		 	  float scalePlus = (scale[9]+0.001f + add[6])/100f;
		 	  float f = 0.6f;
		 	 GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
		       
		 	GlStateManager.func_179137_b(-0.25F, -0.375D, -0.625D);
		       GlStateManager.func_179114_b(-90, 0, 1, 0);
		       
		       Minecraft.func_71410_x().func_175597_ag().func_187462_a(player, items[shieldAt], TransformType.THIRD_PERSON_RIGHT_HAND, false);
		       GlStateManager.func_179121_F();
		   }
		   
//////////quiver TODO //////////////////////////////////////////////////////////////////////////////////////////////////////
		if(items != null && toggleSlots[13] == 1) {
			  boolean hasBowOrCrossbow = false;
			  ItemStack projectile = ServerHelper.AIR_STACK;
			  
			  //PlayerData
			  if(ammo != null && ammo != ServerHelper.AIR_STACK) {
				  projectile = ammo;
				  hasBowOrCrossbow = true;
			  }
			  
			  if(ServerHelper.itemStackExist(projectile)) {
				  int size = projectile.field_77994_a;
				  
				  if(size > 0 && hasBowOrCrossbow) {
					  GlStateManager.func_179094_E();
					  copyModelPartRotation(model, 12, bodyattachment, 1f, 1f);
					  int[] add = {0, 0, 0, 0, 0, 0, 0}; //uniqueSettings(items[shieldAt], 9);
					  GlStateManager.func_179109_b(((float)(slotPositions[36] + add[0])/100f), ((float)(slotPositions[37] + add[1])/100f), ((float)(slotPositions[38] + add[2])/100f));
			
					  float moveBy = hasItems(items, player, moveTypes, 12, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
				      move(moveTypes, 12, moveBy);
				      float moveByArmor = hasEquipments(player, moveTypes, 12) ? 0.038f : 0;
			    	  move(moveTypes, 12, moveByArmor);
					  
					  
					  GlStateManager.func_179114_b(slotRotations[36] + add[3], 1, 0, 0);
					  GlStateManager.func_179114_b(slotRotations[37] + add[4], 0, 1, 0);
					  GlStateManager.func_179114_b(slotRotations[38] + add[5], 0, 0, 1);
					  float scalePlus = (scale[12]+0.001f + add[6])/200f;
					  float f = 0.5f;
					  GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
					  
					  
			       	  quiver.setupAnim(0, player, 0, 0, 0, 0, 0);
					  ResourceLocation texture = HumanoidItemLayer.QUIVER;
					  
					  if(projectile.func_77973_b() != null && projectile.func_77973_b() != ServerHelper.AIR) {
					  	  if(projectile.func_77973_b() instanceof ItemSpectralArrow) {
					  		  ResourceLocation arrow = HumanoidItemLayer.ARROW_TEXTURE_SPECTRAL;
					  		  modelrenderer.func_110776_a(arrow);
//				    		  IVertexBuilder vertexConsumer = p_174522_.getBuffer(RenderType.getEntityCutoutNoCull(arrow));
				    		  arrows.setupAnim(size, player, 0, 0, 0, 0, 0);
				    		  arrows.func_78088_a(player, 0, 0, 0, 0, 0, 1);
				    		  
					  	  }else if(projectile.func_77973_b() instanceof ItemArrow) {
					  		  ResourceLocation arrow = HumanoidItemLayer.ARROW_TEXTURE;
					  		  modelrenderer.func_110776_a(arrow);
//				    		  IVertexBuilder vertexConsumer = p_174522_.getBuffer(RenderType.getEntityCutoutNoCull(arrow));
				    		  arrows.setupAnim(size, player, 0, 0, 0, 0, 0);
				    		  arrows.func_78088_a(player, 0, 0, 0, 0, 0, 1);
					  	  }
					  }
					  
					  modelrenderer.func_110776_a(texture);
//					  IVertexBuilder vertexConsumer = p_174522_.getBuffer(RenderType.getEntityCutoutNoCull(texture));
					  quiver.func_78088_a(player, 0, 0, 0, 0, 0, 1);
					  
					  GlStateManager.func_179121_F();
				  }
			  }
		}
///////////////////////end of quiver///////////////////////////////////////////////6

		   
		   //0
		   for(int slot = 0; slot < 9; slot++) {
			      if(!ServerHelper.isEmpty(items[slot]) && selected != slot && shieldAt != slot && bannerAt != slot && toggleSlots[slot] == 1) {
			    	  GlStateManager.func_179094_E();
			    	  copyModelPartRotation(model, slot, bodyattachment, 1f, 1f);
		
			    	  int[] add = uniqueSettings(items[slot], slot, uniqueItemSettings);
			    	  
			    	  GlStateManager.func_179109_b(((float)(slotPositions[slot*3] + add[0])/100f), ((float)(slotPositions[(slot*3)+1] + add[1])/100f), ((float)(slotPositions[(slot*3)+2] + add[2])/100f));
			          float moveBy = hasItems(items, player, moveTypes, slot, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
				      move(moveTypes, slot, moveBy);
				      float moveByArmor = hasEquipments(player, moveTypes, slot) ? 0.038f : 0;
			    	  move(moveTypes, slot, moveByArmor);
		
			    	  
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3)] + add[3], 1, 0, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 1] + add[4], 0, 1, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 2] + add[5], 0, 0, 1);
		
				      TransformType ctx = TransformType.THIRD_PERSON_RIGHT_HAND;
				      boolean rightHanded = player.func_184591_cq() == EnumHandSide.RIGHT;
				      if(slot == 11) {
				    	  ctx = rightHanded ? TransformType.THIRD_PERSON_RIGHT_HAND : TransformType.THIRD_PERSON_LEFT_HAND;
				      }
				      
				      float scalePlus = (scale[slot]+0.001f + add[6])/100f;
			    	  float f = 1f;
			    	  GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
		
			    	  if(items[slot].func_77973_b() instanceof ItemBow) {
			    		  HumanoidItemLayer.renderBowItem(slot, player, items[slot], ctx);
			    	  }else if((items[slot].func_77973_b() instanceof ItemTool || items[slot].func_77973_b() instanceof ItemSword) && !(items[slot].func_77973_b() instanceof ItemArmor)) {
			    		  HumanoidItemLayer.renderTieredItem(slot, player, items[slot], ctx);
			      	  }else if(whiteListed(items[slot], whitelist)) {
			      		GlStateManager.func_179137_b(0.0F, 0.7D, 0.0D);
			      		GlStateManager.func_179114_b(180, 0, 0, 1);
			    		  HumanoidItemLayer.renderNormalItem(slot, player, items[slot], ctx);
			    	  }
			    	  GlStateManager.func_179121_F();
			      	}
			  	}
		   
		   //offhand
		   int itemslot = 9;
		   int slot = 11;
		   if(!ServerHelper.isEmpty(items[itemslot]) && toggleSlots[slot + 1] == 1 && data.lastOffhandHit >= data.hideTick) {
		 	  if(items[itemslot].func_77973_b() != null && items[itemslot].func_77973_b() instanceof ItemShield) {
		 		 GlStateManager.func_179094_E();
			    	  copyModelPartRotation(model, slot, bodyattachment, 1f, 1f);
			    	  int[] add = uniqueSettings(items[itemslot], 11, uniqueItemSettings);
			    	  
			    	  GlStateManager.func_179109_b(((float)(slotPositions[slot*3] + add[0])/100f), ((float)(slotPositions[(slot*3)+1] + add[1])/100f), ((float)(slotPositions[(slot*3)+2] + add[2])/100f));
			          float moveBy = hasItems(items, player, moveTypes, slot, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
				      move(moveTypes, slot, moveBy);
				      float moveByArmor = hasEquipments(player, moveTypes, slot) ? 0.038f : 0;
			    	  move(moveTypes, slot, moveByArmor);
		
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3)] + add[3], 1, 0, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 1] + add[4], 0, 1, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 2] + add[5], 0, 0, 1);
				      
				      TransformType ctx = TransformType.THIRD_PERSON_RIGHT_HAND;
				      			      
				      GlStateManager.func_179137_b(0.3F, 0.35D, 0.38D);
		
			    	  float scalePlus = (scale[slot]+0.001f + add[6])/100f;
			    	  float f = 0.6f;
			    	  GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
			          
			    	  GlStateManager.func_179137_b(-0.25F, -0.375D, -0.625D);
			    	  GlStateManager.func_179114_b(-90, 0, 1, 0);
			    	  GlStateManager.func_179114_b(-35, 1, 0, 0);
			          Minecraft.func_71410_x().func_175597_ag().func_187462_a(player, items[itemslot], ctx, false);
			          GlStateManager.func_179121_F();

		 	  }else {
		 		 GlStateManager.func_179094_E();
			    	  copyModelPartRotation(model, slot, bodyattachment, 1f, 1f);
			    	  int[] add = uniqueSettings(items[itemslot], 11, uniqueItemSettings);

			    	  GlStateManager.func_179109_b(((float)(slotPositions[slot*3] + add[0])/100f), ((float)(slotPositions[(slot*3)+1] + add[1])/100f), ((float)(slotPositions[(slot*3)+2] + add[2])/100f));
			          float moveBy = hasItems(items, player, moveTypes, slot, selected, shieldAt, bannerAt, toggleSlots) * 0.042f;
				      move(moveTypes, slot, moveBy);
				      float moveByArmor = hasEquipments(player, moveTypes, slot) ? 0.038f : 0;
			    	  move(moveTypes, slot, moveByArmor);

			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + add[3]], 1, 0, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 1] + add[4], 0, 1, 0);
			    	  GlStateManager.func_179114_b(slotRotations[(slot * 3) + 2] + add[5], 0, 0, 1);

				      TransformType ctx = TransformType.THIRD_PERSON_RIGHT_HAND;

				      float scalePlus = (scale[slot]+0.001f + add[6])/100f;
			    	  float f = 1f;
			    	  GlStateManager.func_179152_a(f + scalePlus, f + scalePlus, f + scalePlus);
		
			    	  if(items[itemslot].func_77973_b() instanceof ItemBow) {
			    		  HumanoidItemLayer.renderBowItem(itemslot, player, items[itemslot], ctx);
			    	  }else if((items[itemslot].func_77973_b() instanceof ItemTool || items[itemslot].func_77973_b() instanceof ItemSword) && !(items[itemslot].func_77973_b() instanceof ItemArmor)) {
			    		  HumanoidItemLayer.renderTieredItem(itemslot, player, items[itemslot], ctx);
			      	  }else if(whiteListed(items[itemslot], whitelist)) {
			      		GlStateManager.func_179137_b(0.0F, 0.7D, 0.0D);
			      		GlStateManager.func_179114_b(180, 0, 0, 1);
			      			HumanoidItemLayer.renderNormalItem(itemslot, player, items[itemslot], ctx);
			    	  }
			    	  GlStateManager.func_179121_F();
		 	  	}
		   }
		   
		   GlStateManager.func_179121_F();
	}
}
