package com.minecraftserverzone.weaponmaster.setup.configs;

import java.io.File;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;

import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

public class ConfigHelper
{
    // set up configuration properties (will be read from config file in preInit)
    public static File configFile;
    public static Configuration config;
    public static boolean[] TOGGLE_SLOT_MODEL;
    public static boolean CAN_HIDE_ITEMS, 
	CAN_CHANGE_POS_AND_ROT,
	CAN_CHANGE_SCALE,
	CAN_CHANGE_ATTACHMENT,
	CAN_CHANGE_MOVERS,
	CAN_CHANGE_UNIQUE_ITEM_SETTINGS,
	CAN_CHANGE_BLACKLIST,
	CAN_CHANGE_WHITELIST;
	
	public static int hideTick;
	
	public static int[] positions;
	public static int[] rotations;
	
	public static String slot_attachment;
	public static String slotMover;
	
	public static String blacklist;
	public static String whitelist;
	
	public static String uniqueItemDisplay;
	
	public static int[] scale;
    /**
     * Process the configuration.
     *
     * @param event
     *            the event
     */
    public static void initConfig(FMLPreInitializationEvent event)
    {
        // might need to use suggestedConfigFile (event.getSuggestedConfigFile) location to publish
        configFile = event.getSuggestedConfigurationFile();
        // DEBUG
        System.out.println(WeaponMasterMod.MODID + " config path = " + configFile.getAbsolutePath());
        System.out.println("Config file exists = " + configFile.canRead());

        config = new Configuration(configFile);

        syncConfig();
    }
	
	public static void set(String key, boolean newValue) {
		String category = "general";
		config.getCategory(category).get(key).set(newValue);
		config.save();
	}
	
	public static void set(String key, int newValue) {
		String category = "general";
		config.getCategory(category).get(key).set(newValue);
		config.save();
	}
	
	public static void set(String key, String newValue) {
		String category = "general";
		config.getCategory(category).get(key).set(newValue);
		config.save();
	}

    /**
     * Sync config.
     */
    /*
     * sync the configuration want it public so you can handle case of changes made in-game
     */
    public static void syncConfig() {
        config.load();
        TOGGLE_SLOT_MODEL = new boolean[WeaponMasterMod.maxDisplaySlotNum + 1];
		positions = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
		rotations = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
		scale = new int[WeaponMasterMod.maxDisplaySlotNum];
		
		String category = "general";
		
        //String name, String category, int defaultValue, int minValue, int maxValue, String comment
        //int
        hideTick = config.getInt("hidetick", category, 200, 0, Integer.MAX_VALUE, "put main and off hand items after x tick to display on the body! 100 tick ~ 5 sec");
        
        //string
        uniqueItemDisplay = config.getString("uniqueitems", category, "name,0,0,0,0,0,0,0,1", "put in the name, x,y,z, x-y-z rotation values and the slot where to apply the changes 1-9, shield, banner, offhand! Separate items with a space character");
        
        whitelist = config.getString("whitelist", category, "empty,totem_of_undying", "whitelists item that are normally not visible");

        blacklist = config.getString("blacklist", category, "empty", "blacklists item that are normally visible");
        
        slot_attachment = config.getString("attachment", category, "1-body,2-body,3-rleg,4-lleg,5-rleg,6-lleg,7-body,8-body,9-rleg,shield-body,banner-head,offhand-lleg,quiver-body", "Body part attachment to a slot");
		
		slotMover = config.getString("slot_mover", category, "none,chest;z;+_none,chest,1;z;+_none,legs;x;-_none,legs;x;+_none,legs,3;x;-_none,legs,4;x;+_none,chest,legs,1;z;+_none,shield;z;+_none,legs,3,5;x;-_none;z;-_none;z;-_none,legs,4,6;x;+_none;z;+", "Which active slot and equipment should move the item model away");
		
		//key 1: "_" put this between all slots
		//key 2: ";" put this between types: slots or equipment
		//key 3: "-" put this between the value and variable: x-plus
		//key 4: "," put this between values: 1,2,6,shield, body, legs
		
		initPositionsRotations(config, positions, rotations, scale, 0, 0, 0, -2, 0, 0, 0, 0); 
		initPositionsRotations(config, positions, rotations, scale, 1, 35, 35, 0, 0, 0, 90, 0); 
		initPositionsRotations(config, positions, rotations, scale, 2, 1, -20, 12, 0, -90, 0, 0); 
		initPositionsRotations(config, positions, rotations, scale, 3, 32, -20, 12, 0, -90, 0, 0); 
		initPositionsRotations(config, positions, rotations, scale, 4, 1, -24, 0, 0, -90, -30, 0); 
		initPositionsRotations(config, positions, rotations, scale, 5, 31, -24, 0, 0, -90, -30, 0); 
		initPositionsRotations(config, positions, rotations, scale, 6, -13, 34, -1, 0, 0, -35, 0); 
		initPositionsRotations(config, positions, rotations, scale, 7, 25, 20, 12, 0, 0, 45, 0); 
		initPositionsRotations(config, positions, rotations, scale, 8, 1, -14, 20, 0, -90, 20, 0); 
		initPositionsRotations(config, positions, rotations, scale, 9, 0, 0, 0, 0, 0, 0, 0);
		initPositionsRotations(config, positions, rotations, scale, 10, 0, 0, 0, 0, 0, 0, 0); //banner
		
		initPositionsRotations(config, positions, rotations, scale, 11, -2, 22, -14, 110, 90, 0, 0); //off hand
		initPositionsRotations(config, positions, rotations, scale, 12, 0, 0, 15, 0, 0, 0, 0); //quiver
        
		//boolean
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum + 1; i++) {
			boolean value = true;
			String name = "s"+String.valueOf(i);
			String comment = "Slot "+i;
			
			if(i == 9) {
				name = "shield";
				comment = "shield";
			}else if(i == 10) {
				name = "banner";
				comment = "banner";
			}else if(i == 11) {
				name = "main_hand";
				comment = "main hand";
				value = false;
			}else if(i == 12) {
				name = "off_hand";
				comment = "off hand";
				value = false;
			}else if(i == 13) {
				name = "quiver";
				comment = "quiver";
			}
			TOGGLE_SLOT_MODEL[i] = config.getBoolean(name, category, value, comment);
		}
		
		//server settingss
		category = "server_settings";
		
		CAN_HIDE_ITEMS = config.getBoolean("canhideitems", category, true, "Players can hide items with the toggle settings");
		
		CAN_CHANGE_POS_AND_ROT = config.getBoolean("can_change_pos_and_rot", category, true, "Players can change the position and rotation of the displayed items");
		
		CAN_CHANGE_ATTACHMENT = config.getBoolean("can_change_attachment", category, true, "Players can change the attachment of the slots");
		
		CAN_CHANGE_MOVERS = config.getBoolean("can_change_movers", category, true, "Players can change the movers of the slots");
		
		CAN_CHANGE_UNIQUE_ITEM_SETTINGS = config.getBoolean("can_change_uit", category, true, "Players can change their unique item settings");
		
		CAN_CHANGE_SCALE = config.getBoolean("can_change_scale", category, true, "Players can change their items scale settings");
		
		CAN_CHANGE_BLACKLIST = config.getBoolean("can_change_scale", category, true, "Players can change their blacklist");
		
		CAN_CHANGE_WHITELIST = config.getBoolean("can_change_scale", category, true, "Players can change their whitelist");

        // save is useful for the first run where config might not exist, and doesn't hurt
        config.save();
    }
    
    public static void initPositionsRotations(Configuration builder, int[] pos, int[] rot, int[] scale, int i, int xpos, int ypos, int zpos, int xrot, int yrot, int zrot, int defaultscale) {
		String category = "general";
		
		pos[i * 3] = builder.getInt("x_position"+String.valueOf(i * 3), category, xpos, Integer.MIN_VALUE, Integer.MAX_VALUE, "x position"+String.valueOf(i * 3));
		
		pos[(i * 3)+ 1] = builder.getInt("y_position"+String.valueOf((i * 3)+ 1), category, ypos, Integer.MIN_VALUE, Integer.MAX_VALUE, "y position"+String.valueOf((i * 3)+ 1));
		
		pos[(i * 3)+ 2] = builder.getInt("z_position"+String.valueOf((i * 3)+ 2), category, zpos, Integer.MIN_VALUE, Integer.MAX_VALUE, "z position"+String.valueOf((i * 3)+ 2));
		
		rot[(i * 3)] = builder.getInt("x_rotation"+String.valueOf(i * 3), category, xrot, Integer.MIN_VALUE, Integer.MAX_VALUE, "x rotation"+String.valueOf((i * 3)));
		
		rot[(i * 3)+ 1] = builder.getInt("y_rotation"+String.valueOf((i * 3)+ 1), category, yrot, Integer.MIN_VALUE, Integer.MAX_VALUE, "y rotation"+String.valueOf((i * 3)+ 1));
		
		rot[(i * 3)+ 2] = builder.getInt("z_rotationn"+String.valueOf((i * 3)+ 2), category, zrot, Integer.MIN_VALUE, Integer.MAX_VALUE, "z rotation"+String.valueOf((i * 3)+ 2));
		
		scale[i] = builder.getInt("scale"+String.valueOf(i), category, defaultscale, -100, Integer.MAX_VALUE, "scale"+String.valueOf(i));
	}
    
}
