package com.minecraftserverzone.weaponmaster.setup.events_on_server;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.EmptyItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.RemovePlayerCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SelectedSlotCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SendHandshakeCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerLoggedOutEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent.Phase;
import net.minecraftforge.fml.common.gameevent.TickEvent.PlayerTickEvent;

@EventBusSubscriber()
public class ForgeEvents {
	
//	@SubscribeEvent
//    public static void onPlayerDeath(PlayerEvent.Clone event) {
//		 event.getOriginal().revive();
//		 ((IPlayerData)event.player).setPlayerData(((IPlayerData)event.getOriginal()).getPlayerData());
//		 event.getOriginal().remove(true);
//	}
	
	@SubscribeEvent
	public static void onPlayerRespawn(PlayerEvent.PlayerRespawnEvent event) {
		if(!event.player.func_130014_f_().field_72995_K) {
			EntityPlayerMP player = (EntityPlayerMP) event.player;
			EntityPlayer target = event.player;
			
			ServerHelper.sendAllDataToClient(target, player);
		}
	}
	
	@SubscribeEvent
	public static void onPlayerChangeDimension(PlayerEvent.PlayerChangedDimensionEvent event) {
		if(!event.player.func_130014_f_().field_72995_K) {			
			EntityPlayerMP player = (EntityPlayerMP) event.player;
			EntityPlayer target = event.player;

			ServerHelper.sendAllDataToClient(target, player);
		}
	}
	
	@SubscribeEvent
	public static void onPlayerEntityStartTracking(net.minecraftforge.event.entity.player.PlayerEvent.StartTracking event) {
		if (!(event.getTarget() instanceof EntityPlayer))
		{
			return;
		}
		if(!event.getEntityPlayer().func_130014_f_().field_72995_K) {
			EntityPlayerMP player = (EntityPlayerMP) event.getEntityPlayer();
			EntityPlayer target = (EntityPlayer) event.getTarget();

			ServerHelper.sendAllDataToClient(target, player);
		}
	}

	@SubscribeEvent
	public static void playerLoggedIn(PlayerLoggedInEvent event) {
		EntityPlayer player = event.player;
		if(player != null) {
			//send ip to the player so the player knows he can send packets
//			System.out.println("1.packet to client from server to player: "+player.getName().getString());
			Networking.sendToClient(new SendHandshakeCPacket(player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) player);
		}
	}
	
	@SubscribeEvent
	public static void removePlayerData(PlayerLoggedOutEvent event) {
		EntityPlayer target = event.player;
		if(target != null && !target.field_70170_p.field_72995_K) {
			if(WeaponMasterMod.playerData.containsKey(target.func_70005_c_())) {
				WeaponMasterMod.playerData.remove(target.func_70005_c_());
			}
			
			for(EntityPlayer player : target.field_70170_p.field_73010_i) {
				Networking.sendToClient(new RemovePlayerCPacket(target.func_146094_a(target.func_146103_bH())), (EntityPlayerMP) player);

			}
		}
	}
	
	
	@SubscribeEvent
	public static void playerTick(PlayerTickEvent event) {
		if(event.phase == Phase.END && !event.player.func_130014_f_().field_72995_K) {
			EntityPlayer player = event.player;
			
			if(player != null) {
				PlayerData data = ServerHelper.getPlayerData(player);

				if(data != null && player.field_71071_by != null) {
					//selected slot
					if((player.field_71071_by.field_70461_c != data.selectedSlot)) {
						data.selectedSlot = player.field_71071_by.field_70461_c;
						
						//send packet to all clients who are near to the player
						for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
							if(sp.func_70068_e(player) < 4000) {
								Networking.sendToClient(new SelectedSlotCPacket(player.field_71071_by.field_70461_c, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
							}
						}
					}
					
					//slots
//					System.out.println();
					for(int i = 0; i < 9; i++) {
						if(ServerHelper.itemStackExist(player.field_71071_by.func_70301_a(i))) {
							if(!ServerHelper.areItemStacksEqual(data.inventory[i], player.field_71071_by.func_70301_a(i))) {
								data.inventory[i] = player.field_71071_by.func_70301_a(i).func_77946_l();

								for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
									if(sp.func_70068_e(player) < 4000) {
										if(ServerHelper.itemStackExist(data.inventory[i])) {
											Networking.sendToClient(new ItemStackCPacket(player.field_71071_by.func_70301_a(i).func_77946_l(), i, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//											System.out.println(1 + " - "+ (data.inventory[i]));
										}else {
											Networking.sendToClient(new EmptyItemStackCPacket(i, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//											System.out.println(2);
										}
									}
								}
							}
							
						}else if(ServerHelper.itemStackExist(data.inventory[i])) {
							data.inventory[i] = ServerHelper.AIR_STACK;
//							System.out.println("empty hands on "+i);
							for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
								Networking.sendToClient(new EmptyItemStackCPacket(i, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
							}
						}
					}
					
					//offhand
    				if(ServerHelper.itemStackExist(player.func_184592_cb())) {
    					if(!ServerHelper.areItemStacksEqual(data.inventory[9], player.func_184592_cb())) {
    						data.inventory[9] = player.func_184592_cb().func_77946_l();
    						
    						for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
    							if(sp.func_70068_e(player) < 4000) {
    								if(ServerHelper.itemStackExist(data.inventory[9])) {
    									Networking.sendToClient(new ItemStackCPacket(data.inventory[9], 9, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//    									System.out.println(11);
    								}else {
    									Networking.sendToClient(new EmptyItemStackCPacket(9, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//    									System.out.println(22);
    								}
    							}
    						}
    					}
    				}else if(ServerHelper.itemStackExist(data.inventory[9])) {
    					data.inventory[9] = ServerHelper.AIR_STACK;
//    					System.out.println("empty hands on "+9);
						for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
							Networking.sendToClient(new EmptyItemStackCPacket(9, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
						}
					}
					
					boolean hasProjectileWeaponItem = false;
					boolean hasbow = false;
					
					//ammunition
					for(int j = 0; j < 9; j++) {
						if(data.inventory[j] != null) {
			    			if(data.inventory[j].func_77973_b() instanceof ItemBow) {
			    				hasbow = true;
			    				ItemStack ammo = ServerHelper.getProjectile(player, data.inventory[j]);

			    				if(ServerHelper.itemStackExist(ammo)) {
			    					hasProjectileWeaponItem = true;
			    					
			    					if(!ServerHelper.areItemStacksEqual(data.inventory[10], ammo)) {
			    						data.inventory[10] = ammo.func_77946_l();
			    						for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
			    							if(sp.func_70068_e(player) < 4000) {
			    								if(ServerHelper.itemStackExist(data.inventory[10])) {
					    							Networking.sendToClient(new ItemStackCPacket(data.inventory[10], 10, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//					    							System.out.println(111);
    											}else {
					    							Networking.sendToClient(new EmptyItemStackCPacket(10, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
//					    							System.out.println(222);
    											}
			    							}
			    						}
			    					}
			    				}
				    		}
			    		}
					}
					if((!hasbow && ServerHelper.itemStackExist(data.inventory[10])) || (!hasProjectileWeaponItem && ServerHelper.itemStackExist(data.inventory[10]))){
		    			data.inventory[10] = ServerHelper.AIR_STACK;
//		    			System.out.println((!hasbow && ServerHelper.itemStackExist(data.inventory[10])));

	    				for(EntityPlayer sp : player.func_130014_f_().field_73010_i) {
	    					if(sp.func_70068_e(player) < 4000) {
								Networking.sendToClient(new EmptyItemStackCPacket(10, player.func_146094_a(player.func_146103_bH())), (EntityPlayerMP) sp);
							}
	    				}
		    		}
				}
			}
		}
	}
}
