package com.minecraftserverzone.weaponmaster.setup.helper;

import javax.annotation.Nullable;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.BlacklistCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.EmptyItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.HideTickCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.PositionsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.RotationsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ScaleCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SelectedSlotCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SlotAttachmentCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SlotMoverCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ToggleCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.UniqueItemSettingsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.WhitelistCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemArrow;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;

public class ServerHelper {
	public static final ItemStack EMPTY = new ItemStack((Item)null);
	public static final ItemStack AIR_STACK = new ItemStack(Blocks.field_150350_a);
	public static final Item AIR = Item.func_150898_a(Blocks.field_150350_a);
	

    
    public static boolean itemStackExist(ItemStack a) {
    	if(a != null && a != ServerHelper.EMPTY && a != ServerHelper.AIR_STACK) {
    		if(a.func_77973_b() != null && a.func_77973_b() != AIR && a.func_77973_b() instanceof Item) {
    			return true;
    		}
    	}
    	return false;
    }
	/**
     * compares ItemStack argument1 with ItemStack argument2; returns true if both ItemStacks are equal
     */
    public static boolean areItemStacksEqual(@Nullable ItemStack stackA, @Nullable ItemStack stackB)
    {
        return stackA == null && stackB == null ? true : (stackA != null && stackB != null ? isItemStackEqual(stackA, stackB) : false);
    }

    /**
     * compares ItemStack argument to the instance ItemStack; returns true if both ItemStacks are equal
     */
    public static boolean isItemStackEqual(ItemStack a, ItemStack other)
    {
        if (a.field_77994_a != other.field_77994_a) return false;
        if (a.func_77973_b() != other.func_77973_b()) return false;
        if (a.func_77952_i() != other.func_77952_i()) return false;
        if (!ItemStack.func_77970_a(a, other)) return false;
        return true;
    }
	
	//PlayerData should update when arrow gets decreased
	//arrow slot should be the 10th itemstack when saving the inventory in the PlayerData
	
	public static int ceil(float value)
    {
        int i = (int)value;
        return value > (float)i ? i + 1 : i;
    }
	
    public static boolean isEmpty(ItemStack stack)
    {
        return stack == EMPTY ? true : (getItemRaw(stack) != null && getItemRaw(stack) != Item.func_150898_a(Blocks.field_150350_a) ? (stack.field_77994_a <= 0 ? true : stack.func_77952_i() < -32768 || stack.func_77952_i() > 65535) : true);
    }
    
    public static Item getItemRaw(ItemStack stack)
    {
    	if(stack != null) {
    		if(stack.func_77973_b() != null) {
    			return stack.func_77973_b();
    		}
    	}
        return null;
    }
    
	public static PlayerData getPlayerData(EntityPlayer player) {
		if(!WeaponMasterMod.playerData.containsKey(player.func_70005_c_())) {
			WeaponMasterMod.playerData.put(player.func_70005_c_(), new PlayerData());
			
			return WeaponMasterMod.playerData.get(player.func_70005_c_());
			
		}else {
			return WeaponMasterMod.playerData.get(player.func_70005_c_());
		}
	}
	
	public static boolean isArrow(ItemStack stack) {
		if(stack != null) {
			if(stack.func_77973_b() != null) {
				return stack.func_77973_b() instanceof ItemArrow;
			}
		}
		return false;
	      
	}
	
	public static ItemStack getProjectile(EntityPlayer player, ItemStack shootable) {
		if (isArrow(player.func_184586_b(EnumHand.OFF_HAND))) {
	         return player.func_184586_b(EnumHand.OFF_HAND);
	      } else if (isArrow(player.func_184586_b(EnumHand.MAIN_HAND))) {
	         return player.func_184586_b(EnumHand.MAIN_HAND);
	      } else {
	         for(int i = 0; i < player.field_71071_by.func_70302_i_(); ++i) {
	            ItemStack itemstack = player.field_71071_by.func_70301_a(i);
	            if (isArrow(itemstack)) {
	               return itemstack;
	            }
	         }

	         return AIR_STACK;
	      }
	   }
	
	public static void sendAllDataToClient(EntityPlayer target, EntityPlayerMP player) {
		PlayerData data = ServerHelper.getPlayerData(target);
		
		if(data != null) {
			//int array
			if(data.positions != null) {
				Networking.sendToClient(new PositionsCPacket(data.positions, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.rotations != null) {
				Networking.sendToClient(new RotationsCPacket(data.rotations, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.scale != null) {
				Networking.sendToClient(new ScaleCPacket(data.scale, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.toggleSlots != null) {
				Networking.sendToClient(new ToggleCPacket(data.toggleSlots, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			
			//itemstack
			for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
				if(ServerHelper.itemStackExist(data.inventory[i])) {
					Networking.sendToClient(new ItemStackCPacket(data.inventory[i], i, target.func_146094_a(target.func_146103_bH())), player);
				}else {
					Networking.sendToClient(new EmptyItemStackCPacket(i, target.func_146094_a(target.func_146103_bH())), player);
				}
			}
			
			//int
			Networking.sendToClient(new HideTickCPacket(data.hideTick, false, target.func_146094_a(target.func_146103_bH())), player);
			Networking.sendToClient(new SelectedSlotCPacket(data.selectedSlot, target.func_146094_a(target.func_146103_bH())), player);
			
			//string
			if(data.slotAttachments != null) {
				Networking.sendToClient(new SlotAttachmentCPacket(data.slotAttachments, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.mover != null) {
				Networking.sendToClient(new SlotMoverCPacket(data.mover, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.blacklist != null) {
				Networking.sendToClient(new BlacklistCPacket(data.blacklist, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.whitelist != null) {
				Networking.sendToClient(new WhitelistCPacket(data.whitelist, false, target.func_146094_a(target.func_146103_bH())), player);
			}
			if(data.uniqueItemDisplay != null) {
				Networking.sendToClient(new UniqueItemSettingsCPacket(data.uniqueItemDisplay, false, target.func_146094_a(target.func_146103_bH())), player);
			}
		}
	}
	public static boolean isAirStack(ItemStack value) {
		if(itemStackExist(value)) {
			if(value == ServerHelper.AIR_STACK) {
				return true;
			}
		}
		
		return false;
	}
}
