package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class EmptyItemStackCPacket implements IMessage {

	private int slot;
	private String uuid;

	public EmptyItemStackCPacket() {
	}
	
    public void fromBytes(ByteBuf buf) {
    	this.slot = buf.readInt();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public EmptyItemStackCPacket(int slotnum, UUID uuid) {
    	this.slot = slotnum;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	buf.writeInt(slot);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }


    public static class Handler implements IMessageHandler<EmptyItemStackCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(EmptyItemStackCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(EmptyItemStackCPacket message, MessageContext ctx) {
	   		for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(message.uuid)) {
	    			PlayerData data = ServerHelper.getPlayerData(target);
	    			data.inventory[message.slot] = ServerHelper.AIR_STACK;
				}
			} 
	   	 }
    }
}
