package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class HandActionCPacket implements IMessage {

	private boolean value;
	private String uuid;
	
	public HandActionCPacket() {
	}

    public void fromBytes(ByteBuf buf) {
    	this.value = buf.readBoolean();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public HandActionCPacket(boolean slotnum, UUID uuid) {
    	this.value = slotnum;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	buf.writeBoolean(value);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }

    public static class Handler implements IMessageHandler<HandActionCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(HandActionCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(HandActionCPacket message, MessageContext ctx) {
	   		 for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	   			 if(target.func_146094_a(target.func_146103_bH()).toString().equals(message.uuid)) {
	   				 PlayerData data = ServerHelper.getPlayerData(target);
	   				 if(data != null) {
	   					 if(message.value) {
	   						 data.lastMainhandHit = 1;
	   					 }else {
	   						 data.lastOffhandHit = 1;
	   					 }
 					}
				}
			}
	   	 }
    }
}
