package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class HideTickCPacket implements IMessage {

	private int value;
	private boolean setconfig;
	private String uuid;

	public HideTickCPacket() {
	}
	
    public void fromBytes(ByteBuf buf) {
    	this.value = buf.readInt();
    	this.setconfig = buf.readBoolean();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public HideTickCPacket(int slotnum, boolean setConfigForClient, UUID uuid) {
    	this.value = slotnum;
    	this.setconfig = setConfigForClient;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	buf.writeInt(value);
    	buf.writeBoolean(setconfig);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }

    public static class Handler implements IMessageHandler<HideTickCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(HideTickCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(HideTickCPacket message, MessageContext ctx) {
	   		for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(message.uuid)) {
	    			PlayerData data = ServerHelper.getPlayerData(target);
	 				if(data != null) {
	 					data.hideTick = message.value;
	 					
	 					if(target == Minecraft.func_71410_x().field_71439_g && message.setconfig) {
	 						try{
	 							ConfigHelper.set("hidetick", ConfigHelper.hideTick = data.hideTick);
	 	 	 					ClientOnlyForgeSetup.hideTick = data.hideTick;
	 						}catch (Exception e) {}
	 					}
	 				}
				}
			}
	   	 }
    }
}
