package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class PositionsCPacket implements IMessage {

	private int[] value = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	private boolean setconfig;
	private String uuid;
	
	public PositionsCPacket() {
		
	}

    public void fromBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum * 3; i++) {
			this.value[i] = buf.readInt();
		}
    	this.setconfig = buf.readBoolean();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public PositionsCPacket(int[] slotnum, boolean setConfigForClient, UUID uuid) {
    	this.value = slotnum;
    	this.setconfig = setConfigForClient;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum * 3; i++) {
			buf.writeInt(value[i]);
		}
    	buf.writeBoolean(setconfig);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }


    public static class Handler implements IMessageHandler<PositionsCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(PositionsCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(PositionsCPacket m, MessageContext ctx) {
	   		for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(m.uuid)) {
	    			PlayerData data = ServerHelper.getPlayerData(target);
	 				if(data != null && m.value != null) {
	 					data.positions = m.value;
	 					
	 					if(target == Minecraft.func_71410_x().field_71439_g && m.setconfig) {
	 						for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
	 							try {
	 								ConfigHelper.set("x_position"+String.valueOf((i * 3)), ConfigHelper.positions[(i * 3)] = data.positions[(i * 3)]);
	 								ConfigHelper.set("y_position"+String.valueOf((i * 3)+1), ConfigHelper.positions[(i * 3) + 1] = data.positions[(i * 3)+1]);
	 								ConfigHelper.set("z_position"+String.valueOf((i * 3)+2), ConfigHelper.positions[(i * 3) + 2] = data.positions[(i * 3)+2]);
	 							}catch (Exception e) {}
	 						}

	 						ClientOnlyForgeSetup.slotPositions = data.positions;
	 					}
	 				}
				}
			}
	   	 }
    }
}
