package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class RemovePlayerCPacket implements IMessage {

	private String uuid;
	
	public RemovePlayerCPacket() {
	}

	@Override
    public void fromBytes(ByteBuf buf) {
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public RemovePlayerCPacket(UUID uuid) {
    	this.uuid = uuid.toString();
    }

    @Override
    public void toBytes(ByteBuf buf) {
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }
    
    public static class Handler implements IMessageHandler<RemovePlayerCPacket, IMessage> {
    	
    	 @Override
         public IMessage onMessage(RemovePlayerCPacket message, MessageContext ctx) {
    		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
             return null;
    	 }
    	
    	 @SideOnly(Side.CLIENT)
    	 public void handle(RemovePlayerCPacket message, MessageContext ctx) {
    			for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
    	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(message.uuid)) {
    	    			if(WeaponMasterMod.playerData.containsKey(target.func_70005_c_())) {
    	    				WeaponMasterMod.playerData.remove(target.func_70005_c_());
    	    			}
    				}
    			}
    		}
    }
}
