package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.server.BlacklistSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.HideTickSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.PositionsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.RotationsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.ScaleSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.SelectedSlotSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.SlotAttachmentSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.SlotMoverSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.ToggleSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.UniqueItemSettingsSPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.server.WhitelistSPacket;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class SendHandshakeCPacket implements IMessage {

	private String uuid;
	
	public SendHandshakeCPacket() {
	}

	@Override
    public void fromBytes(ByteBuf buf) {
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public SendHandshakeCPacket(UUID uuid) {
    	this.uuid = uuid.toString();
    }

    @Override
    public void toBytes(ByteBuf buf) {
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }
    
    public static class Handler implements IMessageHandler<SendHandshakeCPacket, IMessage> {
    	
    	 @Override
         public IMessage onMessage(SendHandshakeCPacket message, MessageContext ctx) {
    		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
             return null;
    	 }
    	
    	 @SideOnly(Side.CLIENT)
    	 public void handle(SendHandshakeCPacket message, MessageContext ctx) {
    			for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
    	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(message.uuid)) {
    	    			WeaponMasterMod.isMultiplayer = true;
    	    			
    	    			int[] positionsTemp = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
    	    			int[] rotationsTemp = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
    					int[] scaleTemp = new int[WeaponMasterMod.maxDisplaySlotNum];
    	    			int[] toggleSlotsTemp = new int[WeaponMasterMod.maxDisplaySlotNum + 1];
    	    			
    					ItemStack[] inventory = new ItemStack[WeaponMasterMod.maxDisplaySlotNum];
    					
    	    			for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
    	    				toggleSlotsTemp[i] = ConfigHelper.TOGGLE_SLOT_MODEL[i] ? 1 : 0;
    	    				positionsTemp[i * 3] = ConfigHelper.positions[i * 3];
    	    				positionsTemp[(i * 3)+ 1] = ConfigHelper.positions[(i * 3)+ 1];
    	    				positionsTemp[(i * 3)+ 2] = ConfigHelper.positions[(i * 3)+ 2];

    	    				rotationsTemp[i * 3] = ConfigHelper.rotations[i * 3];
    	    				rotationsTemp[(i * 3)+ 1] = ConfigHelper.rotations[(i * 3)+ 1];
    	    				rotationsTemp[(i * 3)+ 2] = ConfigHelper.rotations[(i * 3)+ 2];
    						scaleTemp[i] = ConfigHelper.scale[i];
    						
    						if(i == 9) {
    							inventory[i] = target.func_184592_cb() == null ? ServerHelper.AIR_STACK : target.func_184592_cb();
    							
    						}else if(i == 10) { //ProjectileWeaponItem -s ammunition
    					    	  inventory[i] = ServerHelper.AIR_STACK;
    								
    					    	  for(int j = 0; j < 9; j++) {
    					    		  if(inventory[j] != null) {
    					    			  if(inventory[j].func_77973_b() instanceof ItemBow) {
    					    				  inventory[i] = ServerHelper.getProjectile(target, inventory[j]);
    						    			  break;
    						    		  }
    					    		  }
    					    	  }
    						}else {
    							inventory[i] = target.field_71071_by.func_70301_a(i) == null ? ServerHelper.AIR_STACK : target.field_71071_by.func_70301_a(i);
    						}
    	    			}

    	    			toggleSlotsTemp[WeaponMasterMod.maxDisplaySlotNum] = ConfigHelper.TOGGLE_SLOT_MODEL[WeaponMasterMod.maxDisplaySlotNum] ? 1 : 0;

    	    			int hideTick = ConfigHelper.hideTick;
    	    			int selectedSlot = target.field_71071_by.field_70461_c;
    	    			
    	    			String slotAttachment  = ConfigHelper.slot_attachment;
    	    			String slotMover  = ConfigHelper.slotMover;
    	    			String blacklist = ConfigHelper.blacklist;
    	    			String whitelist = ConfigHelper.whitelist;

    	    			String uniqueItemSettings = ConfigHelper.uniqueItemDisplay;
    	    			
    	    			
    	    			//send packet back to server to sync config with PlayerData.class
    	    			if(WeaponMasterMod.isMultiplayer) {
    	    				//int array
    	    				Networking.sendToServer(new PositionsSPacket(positionsTemp));
    	    				Networking.sendToServer(new RotationsSPacket(rotationsTemp));
    	    				Networking.sendToServer(new ScaleSPacket(scaleTemp));
    	    				Networking.sendToServer(new ToggleSPacket(toggleSlotsTemp));
    	    				
    	    				//itemstack
//    	    				for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
//    	    					if(ServerHelper.itemStackExist(inventory[i])) { // || inventory[i].isItemEqual(ServerHelper.EMPTY)
//        	    					Networking.sendToServer(new ItemStackSPacket(inventory[i], i));
//    	    					}
//    	    				}
    	    				
    	    				//int
    	    				Networking.sendToServer(new HideTickSPacket(hideTick));
    	    				Networking.sendToServer(new SelectedSlotSPacket(selectedSlot));
    	    				
    	    				//string
    	    				Networking.sendToServer(new SlotAttachmentSPacket(slotAttachment));
    	    				Networking.sendToServer(new SlotMoverSPacket(slotMover));
    	    				Networking.sendToServer(new BlacklistSPacket(blacklist));
    	    				Networking.sendToServer(new WhitelistSPacket(whitelist));
    	    				Networking.sendToServer(new UniqueItemSettingsSPacket(uniqueItemSettings));
    	    				
    	    			}
    				}
    			}
    		}
    }
}
