package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.ModUtils;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class SlotAttachmentCPacket implements IMessage {

	private String value;
	private boolean setconfig;
	private String uuid;
	
	public SlotAttachmentCPacket() {
		
	}

    public void fromBytes(ByteBuf buf) {
    	this.value = ByteBufUtils.readUTF8String(buf);
    	this.setconfig = buf.readBoolean();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public SlotAttachmentCPacket(String slotnum, boolean setConfigForClient, UUID uuid) {
    	this.value = slotnum;
    	this.setconfig = setConfigForClient;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	ByteBufUtils.writeUTF8String(buf, value);
    	buf.writeBoolean(setconfig);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }


    public static class Handler implements IMessageHandler<SlotAttachmentCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(SlotAttachmentCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(SlotAttachmentCPacket m, MessageContext ctx) {
	   		for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(m.uuid)) {
	    			PlayerData data = ServerHelper.getPlayerData(target);
	 				if(data != null && ModUtils.stringExist(m.value)) {
	 					data.slotAttachments = m.value;
	 					
	 					if(target == Minecraft.func_71410_x().field_71439_g && m.setconfig) {
	 						try{
	 							ConfigHelper.set("attachment", ConfigHelper.slot_attachment = data.slotAttachments);
	 	 	 					ClientOnlyForgeSetup.slotAttachment = data.slotAttachments;
	 						}catch (Exception e) {}
	 					}
	 				}
				}
			}
	   	 }
    }
}
