package com.minecraftserverzone.weaponmaster.setup.networking.client;

import java.util.UUID;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class ToggleCPacket implements IMessage {

	private int[] value = new int[WeaponMasterMod.maxDisplaySlotNum + 1];
	private boolean setconfig;
	private String uuid;
	
	public ToggleCPacket() {
		
	}

    public void fromBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum + 1; i++) {
			this.value[i] = buf.readInt();
		}
    	this.setconfig = buf.readBoolean();
    	this.uuid = ByteBufUtils.readUTF8String(buf);
    }

    public ToggleCPacket(int[] slotnum, boolean setConfigForClient, UUID uuid) {
    	this.value = slotnum;
    	this.setconfig = setConfigForClient;
    	this.uuid = uuid.toString();
    }

    public void toBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum + 1; i++) {
			buf.writeInt(value[i]);
		}
    	buf.writeBoolean(setconfig);
    	ByteBufUtils.writeUTF8String(buf, uuid);
    }


    public static class Handler implements IMessageHandler<ToggleCPacket, IMessage> {
    	
    	@Override
        public IMessage onMessage(ToggleCPacket message, MessageContext ctx) {
   		 FMLClientHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            return null;
   	 	}
   	
	   	 @SideOnly(Side.CLIENT)
	   	 public void handle(ToggleCPacket m, MessageContext ctx) {
	   		for(EntityPlayer target : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
	    		if(target.func_146094_a(target.func_146103_bH()).toString().equals(m.uuid)) {
	    			PlayerData data = ServerHelper.getPlayerData(target);
	 				if(data != null && m.value != null) {
	 					data.toggleSlots = m.value;
	 					
	 					if(target == Minecraft.func_71410_x().field_71439_g && m.setconfig) {
	 						for(int i = 0; i < data.toggleSlots.length; i++) {
	 							try{
	 								String name = "s"+String.valueOf(i);
	 								
	 								if(i == 9) {
	 									name = "shield";
	 								}else if(i == 10) {
	 									name = "banner";
	 								}else if(i == 11) {
	 									name = "main_hand";
	 								}else if(i == 12) {
	 									name = "off_hand";
	 								}else if(i == 13) {
	 									name = "quiver";
	 								}
	 								
	 								ConfigHelper.set(name, ConfigHelper.TOGGLE_SLOT_MODEL[i] = data.toggleSlots[i] == 1);
	 							}catch (Exception e) {}
	 						}
	 					}
	 				}
				}
			}
	   	 }
    }
}
