package com.minecraftserverzone.weaponmaster.setup.networking.server;

import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ModUtils;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.BlacklistCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.HideTickCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.PositionsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.RotationsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ScaleCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SlotAttachmentCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SlotMoverCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ToggleCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.UniqueItemSettingsCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.WhitelistCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class GetServerConfigSettingsSPacket implements IMessage {

    public GetServerConfigSettingsSPacket() {
    }
    
    public void fromBytes(ByteBuf buf) {
    }

    public void toBytes(ByteBuf buf) {
    	
    }
    

	public static class Handler implements IMessageHandler<GetServerConfigSettingsSPacket, IMessage> {
        @Override
        public IMessage onMessage(GetServerConfigSettingsSPacket message, MessageContext ctx) {
            // Always use a construct like this to actually handle your message. This ensures that
            // your 'handle' code is run on the main Minecraft thread. 'onMessage' itself
            // is called on the networking thread so it is not safe to do a lot of things
            // here.
            FMLCommonHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            
            return null;
        }

        private void handle(GetServerConfigSettingsSPacket m, MessageContext ctx) {
        	EntityPlayerMP sender = ctx.getServerHandler().field_147369_b; 
 			if (!sender.func_130014_f_().field_72995_K) {
    			PlayerData data = ServerHelper.getPlayerData(sender);
 				if(data != null) {
 					if(ConfigHelper.positions != null) {
 						for(int i = 0; i < ConfigHelper.positions.length; i++) {
 							data.positions[i] = ConfigHelper.positions[i];
 						}
 					}
 					if(ConfigHelper.rotations != null) {
 						for(int i = 0; i < ConfigHelper.rotations.length; i++) {
 							data.rotations[i] = ConfigHelper.rotations[i];
 						}
 					}
 					if(ConfigHelper.scale != null) {
 						for(int i = 0; i < ConfigHelper.scale.length; i++) {
 							data.scale[i] = ConfigHelper.scale[i];
 						}
 					}
 					if(ConfigHelper.TOGGLE_SLOT_MODEL != null) {
 						for(int i = 0; i < ConfigHelper.TOGGLE_SLOT_MODEL.length; i++) {
 							data.toggleSlots[i] = ConfigHelper.TOGGLE_SLOT_MODEL[i]? 1 : 0;
 						}
 					}
 					
 					data.hideTick = ConfigHelper.hideTick;
 						
 					if(ModUtils.stringExist(ConfigHelper.slot_attachment)) {
 						data.slotAttachments = ConfigHelper.slot_attachment;
 					}
 					if(ModUtils.stringExist(ConfigHelper.slotMover)) {
 						data.mover = ConfigHelper.slotMover;
 					}
 					if(ModUtils.stringExist(ConfigHelper.blacklist)) {
 						data.blacklist = ConfigHelper.blacklist;
 					}
 					if(ModUtils.stringExist(ConfigHelper.whitelist)) {
 						data.whitelist = ConfigHelper.whitelist;
 					}
 					if(ModUtils.stringExist(ConfigHelper.uniqueItemDisplay)) {
 						data.uniqueItemDisplay = ConfigHelper.uniqueItemDisplay;
 					}
 					
 					for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 						if(sp.func_70068_e(sender) < 4000) {
 							Networking.sendToClient(new PositionsCPacket(data.positions, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new RotationsCPacket(data.rotations, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new ScaleCPacket(data.scale, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new ToggleCPacket(data.toggleSlots, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							
 							Networking.sendToClient(new HideTickCPacket(data.hideTick, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new SlotAttachmentCPacket(data.slotAttachments, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new SlotMoverCPacket(data.mover, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new BlacklistCPacket(data.blacklist, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new WhitelistCPacket(data.whitelist, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 							Networking.sendToClient(new UniqueItemSettingsCPacket(data.uniqueItemDisplay, true, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 						}
 					}
 				}	
	        }
        }
    }
}
