package com.minecraftserverzone.weaponmaster.setup.networking.server;

import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.EmptyItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ItemStackCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class ItemStackSPacket implements IMessage {

	private ItemStack value;
	private int slot;
	
	public ItemStackSPacket() {
		
	}
	
    public void fromBytes(ByteBuf buf) {
    	this.value = ByteBufUtils.readItemStack(buf);
    	this.slot = buf.readInt();
    }

    public ItemStackSPacket(ItemStack stack, int slotnum) {
    	if(value != null) {
    		this.value = stack;
    	}else {
    		this.value = ServerHelper.AIR_STACK;
    	}
    	this.slot = slotnum;
    }

    public void toBytes(ByteBuf buf) {
    	ByteBufUtils.writeItemStack(buf, value);
    	buf.writeInt(slot);
    }
    

	public static class Handler implements IMessageHandler<ItemStackSPacket, IMessage> {
        @Override
        public IMessage onMessage(ItemStackSPacket message, MessageContext ctx) {
            // Always use a construct like this to actually handle your message. This ensures that
            // your 'handle' code is run on the main Minecraft thread. 'onMessage' itself
            // is called on the networking thread so it is not safe to do a lot of things
            // here.
            FMLCommonHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            
            return null;
        }

        private void handle(ItemStackSPacket m, MessageContext ctx) {
        	EntityPlayerMP sender = ctx.getServerHandler().field_147369_b;
 			if (!sender.func_130014_f_().field_72995_K) {
    			PlayerData data = ServerHelper.getPlayerData(sender);
 				if(data != null && m.value != null) {
 					if(m.slot == 9 && !m.value.func_77969_a(sender.func_184592_cb())) {
 						m.value = sender.func_184592_cb() == null ? ServerHelper.AIR_STACK : sender.func_184592_cb();
						
 					}else if(m.slot == 10 && m.value.func_77969_a(ServerHelper.EMPTY)) {
 						m.value = ServerHelper.AIR_STACK;
 						
 					}else if(!m.value.func_77969_a(sender.field_71071_by.func_70301_a(m.slot))) {
						m.value = sender.field_71071_by.func_70301_a(m.slot);
						
 					}
 					
 					if(ServerHelper.itemStackExist(m.value)) {
 						data.inventory[m.slot] = m.value;
 						
 						for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 	 						Networking.sendToClient(new ItemStackCPacket(data.inventory[m.slot], m.slot, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 	 					}
 					}else {
 						data.inventory[m.slot] = ServerHelper.AIR_STACK;
 						
 						for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 	 						Networking.sendToClient(new EmptyItemStackCPacket(m.slot, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 	 					}
 					}
 				}
	        }
        }
    }
}
