package com.minecraftserverzone.weaponmaster.setup.networking.server;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.RotationsCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class RotationsSPacket implements IMessage {

	private int[] value = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	
	public RotationsSPacket() {
		
	}
	
    public void fromBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum * 3; i++) {
			this.value[i] = buf.readInt();
		}
    }

    public RotationsSPacket(int[] slotnum) {
    	this.value = slotnum;
    }

    public void toBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum * 3; i++) {
			buf.writeInt(value[i]);
		}
    }

	public static class Handler implements IMessageHandler<RotationsSPacket, IMessage> {
        @Override
        public IMessage onMessage(RotationsSPacket message, MessageContext ctx) {
            // Always use a construct like this to actually handle your message. This ensures that
            // your 'handle' code is run on the main Minecraft thread. 'onMessage' itself
            // is called on the networking thread so it is not safe to do a lot of things
            // here.
            FMLCommonHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            
            return null;
        }

        private void handle(RotationsSPacket m, MessageContext ctx) {
        	EntityPlayerMP sender = ctx.getServerHandler().field_147369_b; 
 			if (!sender.func_130014_f_().field_72995_K) {
    			PlayerData data = ServerHelper.getPlayerData(sender);
 				if(data != null && m.value != null) {
 					data.rotations = m.value;
 					
 					if(!ConfigHelper.CAN_CHANGE_POS_AND_ROT && ConfigHelper.rotations != null) {
 						for(int i = 0; i < ConfigHelper.rotations.length; i++) {
 							data.rotations[i] = ConfigHelper.rotations[i];
 						}
 					}
 					
 					for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 						Networking.sendToClient(new RotationsCPacket(data.rotations, false, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 					}
 				}
	        }
        }
    }
}
