package com.minecraftserverzone.weaponmaster.setup.networking.server;

import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.SelectedSlotCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class SelectedSlotSPacket implements IMessage {

	private int value;
	
	public SelectedSlotSPacket() {
		
	}
	
    public void fromBytes(ByteBuf buf) {
    	this.value = buf.readInt();
    }

    public SelectedSlotSPacket(int slotnum) {
    	this.value = slotnum;
    }

    public void toBytes(ByteBuf buf) {
    	buf.writeInt(value);
    }


	public static class Handler implements IMessageHandler<SelectedSlotSPacket, IMessage> {
        @Override
        public IMessage onMessage(SelectedSlotSPacket message, MessageContext ctx) {
            // Always use a construct like this to actually handle your message. This ensures that
            // your 'handle' code is run on the main Minecraft thread. 'onMessage' itself
            // is called on the networking thread so it is not safe to do a lot of things
            // here.
            FMLCommonHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            
            return null;
        }

        private void handle(SelectedSlotSPacket m, MessageContext ctx) {
        	EntityPlayerMP sender = ctx.getServerHandler().field_147369_b;
 			if (!sender.func_130014_f_().field_72995_K) {
    			PlayerData data = ServerHelper.getPlayerData(sender);
 				if(data != null) {
 					data.selectedSlot = m.value;
 					
 					for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 						Networking.sendToClient(new SelectedSlotCPacket(m.value, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 					}
 				}
	        }
        }
    }
}
