package com.minecraftserverzone.weaponmaster.setup.networking.server;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.client.ToggleCPacket;
import com.minecraftserverzone.weaponmaster.setup.playerdata.PlayerData;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class ToggleSPacket implements IMessage {

	private int[] value = new int[WeaponMasterMod.maxDisplaySlotNum + 1];
	
	public ToggleSPacket() {
		
	}
	
	public void fromBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum + 1; i++) {
			this.value[i] = buf.readInt();
		}
    }

    public ToggleSPacket(int[] slotnum) {
    	this.value = slotnum;
    }

    public void toBytes(ByteBuf buf) {
    	for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum + 1; i++) {
			buf.writeInt(value[i]);
		}
    }
    
	public static class Handler implements IMessageHandler<ToggleSPacket, IMessage> {
        @Override
        public IMessage onMessage(ToggleSPacket message, MessageContext ctx) {
            // Always use a construct like this to actually handle your message. This ensures that
            // your 'handle' code is run on the main Minecraft thread. 'onMessage' itself
            // is called on the networking thread so it is not safe to do a lot of things
            // here.
            FMLCommonHandler.instance().getWorldThread(ctx.netHandler).func_152344_a(() -> handle(message, ctx));
            
            return null;
        }

        private void handle(ToggleSPacket m, MessageContext ctx) {
        	EntityPlayerMP sender = ctx.getServerHandler().field_147369_b;
 			if (!sender.func_130014_f_().field_72995_K) {
    			PlayerData data = ServerHelper.getPlayerData(sender);
 				if(data != null && m.value != null) {
 					data.toggleSlots = m.value;
 					
 					if(!ConfigHelper.CAN_HIDE_ITEMS && ConfigHelper.TOGGLE_SLOT_MODEL != null) {
 						for(int i = 0; i < ConfigHelper.TOGGLE_SLOT_MODEL.length; i++) {
 							data.toggleSlots[i] = ConfigHelper.TOGGLE_SLOT_MODEL[i] ? 1 : 0;
 						}
 					}
 					
 					for(EntityPlayer sp : sender.func_130014_f_().field_73010_i) {
 						Networking.sendToClient(new ToggleCPacket(data.toggleSlots, false, sender.func_146094_a(sender.func_146103_bH())), (EntityPlayerMP) sp);
 					}
 				}
	        }
        }
    }
}
